<?php
/**
 * wordpress plugin class for creating affiliate link.
 * Copyright (c) 2010 Nur Hasan
 */
/**
 * For comments, suggestions or bug reporting,
 * contact at: http://www.tipsandtricks-hq.com/contact
 */

include_once plugin_dir_path( __FILE__ ) . 'lib/convertkit/base.php';
include_once plugin_dir_path( __FILE__ ) . 'lib/convertkit/the_interface.php';
include_once plugin_dir_path( __FILE__ ) . 'lib/convertkit/forms.php';
include_once plugin_dir_path( __FILE__ ) . 'lib/cmb2/init.php';
use convertKit\forms;

if ( ! class_exists( 'EarthleyLinkMgr' ) ) {
	class EarthleyLinkMgr {
		var $linkTable;
		var $keywordTable;
		var $clickTable;
		var $linkCount;
		var $redirector_script;
		var $options;
		var $font_family;
		var $link_count;
		var $modified_links;
		var $max_links;
		var $max_per_paragraph;
		var $post_types_enabled;
		var $conversion_rate_threshold;
		var $view_min_threshold;
		var $replacement_link_info;
		var $link_map_for_existing_links;
		var $link_restorable;
		var $postID;
		var $currentcount;
		var $currentparagraph;
		var $ref_id;
//    	function Earthley(){
//    	    $this->__construct();
//
//    	}

		function __construct() {
			global $wpdb;
			$this->wpdb = $wpdb;
			global $wp_rewrite;
			$this->wp_rewrite = $wp_rewrite;
			if ( empty( $wp_rewrite ) ) {
				$GLOBALS['wp_rewrite'] = new WP_Rewrite();
			}
			$this->linkTable                   = $this->wpdb->prefix . 'earthleylinkmgr_links';
			$this->clickTable                  = $this->wpdb->prefix . 'earthleylinkmgr_clicks';
			$this->keywordTable                = $this->wpdb->prefix . 'earthleylinkmgr_keywords';
			$this->currentparagraph            = 0;
			$this->link_count                  = - 1;
			$this->link_restorable             = true;
			$this->replacement_link_info       = array();
			$this->link_map_for_existing_links = array();
			$this->modified_links              = array();
			$this->options                     = get_option( 'earthleylinkmgr_settings' );
			$this->max_links                   = -1; //not currently used $max_links = is_numeric( $this->options['max_links'] ) ? $this->options['max_links'] : - 1;
			$this->ref_id                      = isset( $this->options['ref_id'] ) ? $this->options['ref_id'] : ""; //$ref_id = ! is_numeric( $this->options['max_links'] ) ? $this->options['max_links'] : "";
			$this->max_per_paragraph           = $max_per_paragraph = is_numeric( $this->options['max_per_paragraph'] ) ? $this->options['max_per_paragraph'] : - 1;
			$this->post_types_enabled          = $post_types_enabled = isset( $this->options['post_types_enabled'] ) ? $this->options['post_types_enabled'] : "post";
			$this->currentcount                = 0;
			$this->conversion_rate_threshold   = 25.00;
			$this->view_min_threshold          = 100;
			$this->initialKeywords             = array();
			$this->font_family                 = array(
				'Arial, Helvetica, sans-serif',
				'"Arial Black", sans-serif',
				'"Comic Sans MS", cursive',
				'"Courier New", Courier, monospace'
			);
			$this->admin_pages                 = array(
				'earthleylinkmgr-class.php',
				'earthleylinkmgr_settings'
			);
			$this->redirector_script           = WP_PLUGIN_URL . '/' . WP_EARTHLEYLINKMGR_FOLDER . '/redirector.php';
			register_activation_hook( WP_PLUGIN_DIR . '/' . WP_EARTHLEYLINKMGR_FOLDER . '/' . 'earthleylinkmgr.php', array(
				&$this,
				'activate'
			) );
			register_deactivation_hook( WP_PLUGIN_DIR . '/' . WP_EARTHLEYLINKMGR_FOLDER . '/' . 'earthleylinkmgr.php', array(
				&$this,
				'deactivate'
			) );
			if ( is_admin() ) {
				add_action( 'admin_menu', array( &$this, 'wp_earthleylinkmgr_admin_menu' ) );
				//check if refid was added
                if(!$this->ref_id) {
                    add_action('admin_notices', array( &$this, 'wp_earthleylinkmgr_refid_error') );
                }
			}
			if ( ! empty( $this->options['link_for_comment'] ) ) {
				add_action( 'comment_text', array( &$this, 'earthleylinkmgr_replace_link' ) );
			}
			if ( ! empty( $this->options['link_for_widget'] ) ) {
				add_action( 'widget_text', array( &$this, 'earthleylinkmgr_replace_link' ) );
			}

			if ( ! is_admin() ) {
				add_action( 'init', array( &$this, 'redirect' ) );
				add_action( 'wp_head', array( &$this, 'earthleylinkmgr_wp_head_hook' ), 9000 );
			}
			add_filter( 'the_content', array( &$this, 'earthleylinkmgr_replace_link' ), - 2000 );
			add_action( 'init', array( &$this, 'loadLibrary' ) );
			add_action( 'load-toplevel_page_earthleylinkmgr/earthleylinkmgr-class', array( &$this, 'admin_library' ) );
			add_action( 'load-link-manager_page_earthleylinkmgr_settings', array( &$this, 'admin_library' ) );
			add_action( 'wp_ajax_list_link', array( &$this, 'earthleylinkmgr_list_link_ajax' ) );
			add_action( 'wp_ajax_load_form', array( &$this, 'earthleylinkmgr_load_form_ajax' ) );
			add_action( 'wp_ajax_process_form', array( &$this, 'earthleylinkmgr_process_form_ajax' ) );
			add_action( 'wp_ajax_delete_link', array( &$this, 'earthleylinkmgr_delete_link_ajax' ) );
			add_action( 'wpmu_new_blog', array( &$this, 'new_blog' ), 10, 6 );
            add_action( 'cmb2_admin_init', array( &$this, 'setup_post_exclusion' ) );
			$parts = parse_url( get_option( 'siteurl' ) );
			$http  = 'http';
			if ( isset( $_SERVER["HTTPS"] ) && ( $_SERVER["HTTPS"] == "on" ) ) {
				$http .= "s";
			}
			$http       .= "://";
			$this->host = $http . $parts['host'] . ( isset( $parts['path'] ) ? $parts['path'] : "" );
		}

        function wp_earthleylinkmgr_refid_error() {
            $class = 'notice notice-error';
            $message = __( 'Earthley Affiliate Link Manager - warning you CAN NOT be paid for commissions until you add your Affiliate ID in the settings.', 'earthleylinkmgr' );

            printf( '<div class="%1$s"><p>%2$s</p></div>', esc_attr( $class ), esc_html( $message ) );
        }


		function new_blog( $blog_id, $user_id, $domain, $path, $site_id, $meta ) {
			if ( is_plugin_active_for_network( pathinfo( WP_EARTHLEYLINKMGR_FOLDER . '/earthleylinkmgr.php' ) ) ) {
				$old_blog = $this->wpdb->blogid;
				switch_to_blog( $blog_id );
				$this->_activate();
				switch_to_blog( $old_blog );
			}
		}

		function redirect() {
			global $wp_rewrite;
			$requested_url = $_SERVER['REQUEST_URI'];
			$link_prefix   = isset( $this->options['link_prefix'] ) ? $this->escapize( $this->options['link_prefix'] ) : "link/";
			$token         = false;
			if ( $wp_rewrite->using_mod_rewrite_permalinks() ) {
				$token = explode( '/', stristr( $requested_url, $link_prefix ) );
				$token = isset( $token[1] ) ? $token[1] : false;
			} else {
				$token = isset( $_GET['link_mgr_token'] ) ? $_GET['link_mgr_token'] : false;
			}
			if ( $token ) {
				$token = str_replace( '_', ' ', $token );
				$url   = $this->getDestination( $token );
				if ( ! $url ) {
					$url = get_option( 'siteurl' );
				} else {
					$this->click( $token );
				}
				if ( ( strpos( $url, 'http' ) === false ) ) {
					$url = 'http://' . $url;
				}
				header( "Location: {$url}" );
				exit();
			}
		}

		function wp_earthleylinkmgr_admin_menu() {
			add_menu_page( __( "Earthley Link Manager", 'earthleylinkmgr' ), __( "Earthley Link Manager", 'earthleylinkmgr' ), "add_users", __FILE__, array(
				&$this,
				"earthleylinkmgr_manage"
			) );
			add_submenu_page( __FILE__, __( "Earthley Link Manager::Manage", 'earthleylinkmgr' ), __( "Manage Links", 'earthleylinkmgr' ), "add_users", __FILE__, array(
				&$this,
				"earthleylinkmgr_manage"
			) );
			add_submenu_page( __FILE__, __( "Earthley Link Manager::Settings", 'earthleylinkmgr' ), __( "Settings", 'earthleylinkmgr' ), "add_users", "earthleylinkmgr_settings", array(
				&$this,
				"earthleylinkmgr_settings"
			) );
		}

		function earthleylinkmgr_wp_head_hook() {
			echo '<style type="text/css" media="screen">' . "\n";
			echo '.earthleylinkmgr_link_style{' . "\n";
			echo ( isset( $this->options['custom_font_color'] ) && $this->options['custom_font_color'] ) ? 'color:' . $this->options['custom_font_color'] . " !important;\n" : "";
			echo ( isset( $this->options['custom_font_family'] ) && $this->options['custom_font_family'] ) ? 'font-family:' . $this->font_family[ $this->options['custom_font_family'] ] . ";\n" : "";
			echo ( isset( $this->options['custom_font_size'] ) && ( $this->options['custom_font_size'] != 0 ) ) ? 'font-size:' . $this->options['custom_font_size'] . $this->options['custom_font_size_unit'] . ";\n" : "";
			echo ( isset( $this->options['custom_font_bold'] ) && $this->options['custom_font_bold'] ) ? "font-weight:bold;\n" : "";
			echo ( isset( $this->options['custom_font_italic'] ) && $this->options['custom_font_italic'] ) ? "font-style:italic;\n" : "";
			echo ( isset( $this->options['custom_font_underline'] ) && $this->options['custom_font_underline'] ) ? "text-decoration:underline;\n" : "";
			echo ( isset( $this->options['custom_css'] ) && $this->options['custom_css'] ) ? $this->options['custom_css'] . ";\n" : "";
			echo '}' . "\n";
			echo '</style>';
		}

		function admin_library() {
			global $wp_version;
			wp_enqueue_script( 'jquery' );
			wp_enqueue_script( 'jquery.paginateN', WP_EARTHLEYLINKMGR_URL . '/js/jquery.paginateN-1.0.js' );
			wp_enqueue_script( 'jquery.formN', WP_EARTHLEYLINKMGR_URL . '/js/jquery.formN-1.0.js' );
			wp_enqueue_script( 'jquery.colorpicker', WP_EARTHLEYLINKMGR_URL . '/js/jquery.colorpicker.js' );
			wp_enqueue_style( 'jquery.paginateN', WP_EARTHLEYLINKMGR_URL . '/css/jquery.paginateN-1.0.css' );
			wp_enqueue_style( 'earthley', WP_EARTHLEYLINKMGR_URL . '/css/earthleylinkmgr.css' );
			wp_enqueue_style( 'jquery.colorpicker', WP_EARTHLEYLINKMGR_URL . '/css/jquery.colorpicker.css' );
			if ( version_compare( $wp_version, '3.5', '<' ) )//fix until jquerytools releases version compatible with jquery 1.8.3
			{
				wp_enqueue_script( 'jquery.tools', WP_EARTHLEYLINKMGR_URL . '/js/jquery.tools.min.js' );
			} else {
				wp_enqueue_script( 'jquery.tools', WP_EARTHLEYLINKMGR_URL . '/js/jquery.tools18.min.js' );
			}

		}

		function loadLibrary() {
			if ( ! is_admin() ) {
				wp_enqueue_style( 'earthleylinkmgr', WP_EARTHLEYLINKMGR_URL . '/css/earthleylinkmgr.css' );
			}
		}

		function earthleylinkmgr_manage() {
			include_once( 'earthleylinkmgr_manage.php' );
		}

		function earthleylinkmgr_settings() {
			global $wp_rewrite;
			$updated          = false;
			if (isset($_POST['post_types_enabled'])) {
				$_POST['earthleylinkmgr_options']['post_types_enabled'] = json_encode($_POST['post_types_enabled']);
			}
			$earthleylinkmgr_options = isset( $_POST['earthleylinkmgr_options'] ) ?
				$_POST['earthleylinkmgr_options'] : get_option( 'earthleylinkmgr_settings' );
			$settings         = array(
				'enable_keyword_to_link',
				'open_in_new_window',
				'use_nofollow',
				'count_clicks',
				'link_for_page',
				'link_for_post',
				'link_for_comment',
				//'custom_font_bold',
				//'custom_font_italic',
				//'custom_font_underline',
				'link_prefix',
				'max_per_paragraph',
				'post_types_enabled',
                'wisdom_registered_setting'
			);
			foreach ( $settings as $item ) {
				$earthleylinkmgr_options[ $item ] = isset( $earthleylinkmgr_options[ $item ] ) ?
					$earthleylinkmgr_options[ $item ] : "";
			}

			//for tracking program
            $earthleylinkmgr_options['wisdom_registered_setting'] = 1;

			if ( isset( $_POST['Submit'] ) ) {
				update_option( 'earthleylinkmgr_settings', $earthleylinkmgr_options );

				$wp_rewrite->flush_rules();
				$updated = true;
			}
			include_once( 'earthleylinkmgr_settings.php' );
			$this->options['post_types_enabled'] = $earthleylinkmgr_options['post_types_enabled'];
		}

		function earthleylinkmgr_delete_link_ajax() {
			$this->linkTable    = $this->wpdb->prefix . 'earthleylinkmgr_links';
			$this->clickTable   = $this->wpdb->prefix . 'earthleylinkmgr_clicks';
			$this->keywordTable = $this->wpdb->prefix . 'earthleylinkmgr_keywords';
			$query              = 'DELETE FROM ' . $this->linkTable . ' WHERE id= ' . $_GET['id'];
			$this->wpdb->query( "DELETE FROM {$this->clickTable} WHERE {$this->clickTable}.link_id= {$_GET['id']}" ); //Delete from earthleylinkmgr_clicks
			$this->wpdb->query( "DELETE FROM {$this->keywordTable} WHERE {$this->keywordTable}.link_id = {$_GET['id']}" ); //Delete from earthleylinkmgr_keywords
			$this->wpdb->query( $query ); //Delete from earhtley_links
			echo "deleted";
			die();
		}

        /**
         * Add fields to the options metabox
         */
        public function setup_post_exclusion() {
            $post_meta = new_cmb2_box( array(
                'id' => 'earthleylinkmgr_metabox',
                'title' => __( 'Earthley Affiliate Link Manager', 'earthleylinkmgr' ),
                'object_types' => array( 'post' ),
            ) );

            $post_meta->add_field( array(
                'name' => __( 'Disable all links', 'earthleylinkmgr' ),
                'id' => 'earthleylinkmgr_disable',
                'type' => 'checkbox',
            ) );
        }

		function keyword2link( $matches ) {

//            echo "matches<pre>";
//            print_r($matches);
//            echo "</pre>";

		    //this is where it's doing header insertion?

			if ( empty( $matches[0] ) ) {
				return "";
			}

            //added blt 10/19/18
            if(isset($this->paragraphLink)){
                if(array_key_exists($this->currentparagraph, $this->paragraphLink)) {
                    $count = count($this->paragraphLink[$this->currentparagraph]);
                } else {
                    $count = 0;
                }
            } else {
			    $count = 0;
            }

			if ( $count < $this->max_per_paragraph ) {
                $lword = strtolower($matches[0]);

				//added blt 10/19/18
                if(!array_key_exists('paragraphLink', $this)) {
                    $plcount = 0;
                } else {
                    if (!array_key_exists($this->currentparagraph, $this->paragraphLink)) {
                        $plcount = 0;
                    } else {
                        if (!array_key_exists($lword, $this->paragraphLink[$this->currentparagraph])) {
                            $plcount = 0;
                        } else {
                            $plcount = $this->paragraphLink[$this->currentparagraph][$lword]['count'];
                        }
                    }
                }

//                if ( ! array_key_exists($lword, $this->replacement_link_info) ) {
//                    $this->initialKeywords[$this->initialCounter] = $lword;
//                    $this->replacement_link_info[$lword]['count'] = 1; //$this->replacement_link_info[$lword]['count'] + 1;
//                    $this->initialCounter++;
//                }

				if ( ( $this->replacement_link_info[ $lword ]['count'] > 0 ) && ( $plcount ) > 0 ) {
					return $matches[0];
				}
				$this->link_count ++;
				$this->paragraphLink[ $this->currentparagraph ][ $lword ]['count'] = $plcount + 1;
				$this->replacement_link_info[ $lword ]['count']                    = $this->replacement_link_info[ $lword ]['count'] + 1;
				$this->modified_links[ $this->link_count ]['url']                  = $this->replacement_link_info[ $lword ]['url'];
				$this->modified_links[ $this->link_count ]['key']                  = $matches[0];
				$this->modified_links[ $this->link_count ]['flag']                 = 'i';
				$this->updateKeyword[ $this->link_count ]                          = $matches[0];

				return "#" . $this->link_count . "@";
			} else {
				return $matches[0];
			}
		}

		function modify_keywork_in_link( $matches ) {
			if ( empty( $matches['name'] ) ) {
				$matches['name'] = "";
			}

			$this->link_count ++;
			$replaced = false;
			foreach ( $this->link_map_for_existing_links as $item ) {
				if ( in_array( $matches['name'], $item['words'] ) ) {
					$replaced                                          = true;
					$this->modified_links[ $this->link_count ]['url']  = $item['url'];
					$this->modified_links[ $this->link_count ]['key']  = $matches['name'];
					$this->modified_links[ $this->link_count ]['flag'] = 'i';
				}
			}
			if ( ! $replaced ) {
				$this->modified_links[ $this->link_count ]['url']  = $matches[0];
				$this->modified_links[ $this->link_count ]['key']  = "";
				$this->modified_links[ $this->link_count ]['flag'] = 'c';
			}

			return "#" . $this->link_count . "@";
		}

		function modify_img_link( $matches ) {
			$this->link_count ++;
			$this->modified_links[ $this->link_count ]['url']  = $matches[0];
			$this->modified_links[ $this->link_count ]['key']  = "";
			$this->modified_links[ $this->link_count ]['flag'] = 'img';

			return "#" . $this->link_count . "@";
		}

		function restore_keywork_in_link( $matches ) {
			$this->link_restorable = true;
			$index                 = trim( $matches[0], "#@" );
			if ( empty( $this->modified_links[ $index ] ) ) {
				return "";
			}
			$link_info = $this->modified_links[ $index ];
			if ( $link_info['flag'] == 'img' ) {
				return $link_info['url'];
			}
			if ( $link_info['flag'] == "c" ) {
				return $link_info['url'];
			}
			if ( empty( $link_info['key'] ) ) {
				return "";
			}

			return $link_info['url'] . $link_info['key'] . '</a>';
		}

		function earthleylinkmgr_replace_link( $content ) {
			$startTime = microtime( true );
			$this->postID            = $_POST['postID'] = get_the_ID();
			$findPostType = $this->findPostID();
			if ( is_home() || is_admin() || is_preview() ) {
				return $content;
			}
			if ( is_page() && ! ( $this->options['link_for_page'] ) ) {
				return $content;
			}
			if ( is_feed() ) {
				return $content;
			}
            if( get_post_meta($this->postID, 'earthleylinkmgr_disable', true) == 'on') { //if user has chosen to not display links on this individual page
                return $content;
            }

			// i don't have the energy to deal with this atm...
//			if ( ! $this->options['link_for_post'] ) {
//				return $content;
//			}
//			if (in_array($findPostType, json_decode($this->options['post_types_enabled']))) {
//				return $content;
//			}

			$currentCountInParagraph = 0;
			$pTagSeperatedContent    = $this->seperateByParagraph( $content );

			$link_patterns                     = '/(<a\s*';
			$link_patterns                     .= '(.*?)\s*';
			$link_patterns                     .= 'href=[\'"]+?\s*(?P<link>\S+)\s*[\'"]+?';
			$link_patterns                     .= '\s*(.*?)\s*>\s*';
			$link_patterns                     .= '(?P<name>(.*?)\S+)';
			$link_patterns                     .= '\s*<\/a>)/i';

            //list of all keywords in the database
			$result                            = $this->obtainAllKeywords();
/*
			echo "<pre>";
			print_r($result);
			echo "</pre>";
*/
            //echo "content1: ".$content."<br><br>";

			$this->link_map_for_existing_links = array();

			//no idea what this does
			$content                           = preg_replace_callback( '/(.?)\[(caption)\b(.*?)(?:(\/))?\](?:(.+?)\[\/\2\])?(.?)/', array(
				$this,
				"modify_keywork_in_link"
			), $content );

            //echo "content2: ".$content."<br><br>";

            //no idea what this does
			$content                           = preg_replace_callback( '/<img[^>]+>/i', array(
				$this,
				"modify_img_link"
			), $content );

            //echo "content3: ".$content."<br><br>";

//            echo "before<pre>";
//            print_r($this);
//            echo "</pre>";

            //get list of keywords that exist in the content
			$this->initialKeywords             = $this->findInitialKeywords( $result, $content );

//            echo "after<pre>";
//            print_r($this);
//            echo "</pre>";
/*
            echo "<pre>";
            print_r($this->initialKeywords);
            echo "</pre>";
*/
			$this->amountofParagraphs          = ( count( $pTagSeperatedContent ) );
			//echo $this->amountofParagraphs;

			//reverse the keyword order, so it's longest value to shortest (so compound words will get picked first)
			usort( $this->initialKeywords, array( $this, 'reverseOrder' ) );

            //i believe that this is getting the link/url for each keyword
			for ( $i = 0; $i < count( $this->initialKeywords ); $i ++ ) {
				$stmt                              = $this->wpdb->get_results( "SELECT {$this->keywordTable}.keywords FROM {$this->keywordTable} WHERE {$this->keywordTable}.keywords = '".str_replace('\'', '\\\'',$this->initialKeywords[$i])."'" );
				$a[]                               = $this->generateLinks( $stmt );
				$a[ $this->initialKeywords[ $i ] ] = $a[ $i ]["{$this->initialKeywords[$i]}"];
				unset( $a[ $i ] );
				$this->link_map_for_existing_links[] = array(
					'url'   => $a[ $this->initialKeywords[ $i ] ],
					'words' => $this->initialKeywords[ $i ]
				);
				if ( $this->replacement_link_info[ $this->initialKeywords[ $i ] ] ) {
					$this->replacement_link_info[ $this->initialKeywords[ $i ] ]['url'] = $a[ $this->initialKeywords[ $i ] ]['link'];
				}
			}

//            echo "<pre>";
//            print_r($this->replacement_link_info);
//            echo "</pre>";

			$this->currentparagraph = 0;
			for ( $r = 0; $r < $this->amountofParagraphs; $r ++ ) {
				unset( $this->paragraphKeywords );
				$this->testingShit[ $r ]    = $this->findParagraphKeywords( $pTagSeperatedContent[ $r ] ); //i believe this is only building the click table
                $this->testingLinks[ $r ]   = $this->getLinks4( $r );
				$pTagSeperatedContent[ $r ] = $this->transformKeywords2( $pTagSeperatedContent[ $r ], $content, $r);
				$this->currentparagraph++;
			}

//            echo "<pre>";
//            print_r($this);
//            echo "</pre>";

			$content = preg_replace_callback( '/#\d+@/', array(
				$this,
				"restore_keywork_in_link"
			), implode( " ", $pTagSeperatedContent ) );
			//for testing
			//error_log("Elapsed time is: " . ( microtime( true ) - $startTime ) . " seconds");

			return $content;
		}

		function earthleylinkmgr_list_link_ajax() {
			$this->linkTable    = $this->wpdb->prefix . 'earthleylinkmgr_links';
			$this->keywordTable = $this->wpdb->prefix . 'earthleylinkmgr_keywords';
            $this->clicksTable = $this->wpdb->prefix . 'earthleylinkmgr_clicks';
			$condition          = isset( $_GET['s'] ) ? ' link_title LIKE \'' . $_GET['s'] . '%\'' : "";
			$limit              = is_numeric( $this->options['items_per_page'] ) ? (int) floor( $this->options['items_per_page'] ) : 10;
			$page               = isset( $_GET['page'] ) ? $_GET['page'] : 1;
			$start              = ( $page - 1 ) * $limit;

			$query  = 'SELECT * FROM ' . $this->linkTable;
			$query  .= $condition ? ' WHERE ' . $condition : '';
			$query  .= ' ORDER BY `master_record` ASC LIMIT ' . $start . ' , ' . $limit;
			$result = $this->wpdb->get_results( $query, OBJECT );
			$query  = "SELECT COUNT(*) FROM " . $this->linkTable;
			$query  .= $condition ? ' WHERE ' . $condition : '';
			$count  = $this->wpdb->get_var( $query );
			$pages  = ceil( $count / $limit );
			$prefix = isset( $this->options['link_prefix'] ) ? $this->options['link_prefix'] : "link";

			for ( $i = 0; $i < count( $result ); $i ++ ) {
				$stmt = $this->wpdb->get_results( "SELECT {$this->keywordTable}.keywords FROM {$this->keywordTable} WHERE link_id = {$result[$i]->id}" );
				for ( $j = 0; $j < count( $stmt ); $j ++ ) {
					$keywords[] = $stmt[ $j ]->keywords;
				}

				$result[ $i ]->keywords = implode( ", ", $keywords );
                unset( $keywords );

                $stmt2 = $this->wpdb->get_results( "SELECT sum(`click_count`) as 'count' FROM {$this->clicksTable} WHERE link_id = {$result[$i]->id}" );

                if (!is_null($stmt2[0]->count)) {
                    $result[$i]->click_count = $stmt2[0]->count;
                } else {
                    $result[$i]->click_count = 0;
                }
			}

			include_once( 'earthleylinkmgr_list_link_ajax.php' );
			die();
		}

		function earthleylinkmgr_load_form_ajax() {
			if ( isset( $_POST['link_id'] ) ) {
				$this->linkTable    = $this->wpdb->prefix . 'earthleylinkmgr_links';
				$this->keywordTable = $this->wpdb->prefix . 'earthleylinkmgr_keywords';
				$query              = "SELECT * FROM {$this->linkTable} WHERE id= {$_POST['link_id']}";
				$stmt               = $this->wpdb->get_results( "SELECT {$this->keywordTable}.keywords FROM {$this->keywordTable} WHERE link_id = {$_POST['link_id']}" );
				$keywords           = [];

				for ( $i = 0; $i < count( $stmt ); $i ++ ) {
					$keywords[ $i ] = $stmt[ $i ]->keywords;
				}

				$result           = $this->wpdb->get_row( $query, OBJECT );
				$result->keywords = implode( ", ", $keywords );
			}


			$this->options['link_prefix'] = "link";
			$prefix                       = isset( $this->options['link_prefix'] ) ? $this->options['link_prefix'] : "link";
			ob_start();
			include_once( 'earthleylinkmgr_load_form_ajax.php' );
			$contents = ob_get_contents();
			ob_end_clean();
			echo json_encode( array( 'event' => 'init', 'payload' => $contents ) );
			die();
		}

		function earthleylinkmgr_process_form_ajax() {
			unset( $_POST['action'] );
			$this->linkTable    = $this->wpdb->prefix . 'earthleylinkmgr_links';
			$this->clickTable   = $this->wpdb->prefix . 'earthleylinkmgr_clicks';
			$this->keywordTable = $this->wpdb->prefix . 'earthleylinkmgr_keywords';
			$event              = 'failed';
			$payload            = 'Couldn\'t save data.';
			if ( empty( $_POST['alias_link'] ) ) {
				$event   = 'failed';
				$payload = 'Link Alias Field Cannot be Empty.';
			} else {

				$_POST['escaped_alias_link'] = $this->escapize( $_POST['alias_link'] );
				$token                       = $_POST['escaped_alias_link'];
				$payload                     = 'Link Added.';
				$linkVariables               = [
					"link_title"         => $_POST['link_title'],
					"link_dest"          => $_POST['link_dest'],
					"alias_link"         => $_POST['alias_link'],
					"escaped_alias_link" => $_POST['escaped_alias_link'],
					"new_window"         => 1,
					"no_follow"          => 1,
					"active"             => 1
				]; //Puts all the post variables into 1, so I can be sane..
				$clickVariables              = []; //Variables received for the wp_earthleylinkmgr_clicks table
				$keywordVariables            = explode( ', ', $_POST['keywords'] ); //Takes the values from the post-data multi-array and puts them into a simple array so I don't kill children
				$alias                       = $this->wpdb->get_row( "SELECT {$this->keywordTable}.keywords, {$this->keywordTable}.link_id FROM {$this->keywordTable} JOIN {$this->linkTable} ON {$this->linkTable}.id = {$this->keywordTable}.link_id WHERE {$this->linkTable}.escaped_alias_link = '{$token}' LIMIT 1;" );
				if ( empty( $alias ) || ( $_POST['id'] == $alias->link_id ) ) {
					if ( isset( $_POST['id'] ) ) {
						$id = $_POST['id'];
						unset( $_POST['id'] );
						/*
						 * Going to have to edit this for the settings
						 * I believe most of them are going to be ON by DEFAULT.
						 */
						$_POST['track_clicks']           = 1;
						$_POST['new_window']             = 1;
						$_POST['no_follow']              = 1;
						$_POST['active']                 = 1;
						$_POST['replace_existing_links'] = 1;

						$this->wpdb->update( $this->linkTable, $linkVariables, array( 'id' => $id ) );
						$this->wpdb->query( "DELETE FROM {$this->keywordTable} WHERE {$this->keywordTable}.link_id = {$id}" );
						for ( $i = 0; $i < count( $keywordVariables ); $i ++ ) {
							$this->wpdb->insert( $this->keywordTable, array(
								'link_id'  => $id,
								'keywords' => $keywordVariables[ $i ]
							) ); //Inserts keywords into wp_earthleylinkmgr_keywords: link_id, keywords
						}
						$payload = 'Link Updated.';
					} else {
						unset( $_POST['keywords'] );
						$this->wpdb->insert( $this->linkTable, $linkVariables ); //insert the values from the form to wp_earthleylinkmgr_links
						$stmt      = $this->wpdb->get_results( "SELECT {$this->linkTable}.id FROM {$this->linkTable} WHERE {$this->linkTable}.link_title = '{$linkVariables['link_title']}'" ); //Provides current link_id value
						$newLinkID = $stmt[0]->id;
//                        $stmt = $this->wpdb->get_results("SELECT {$this->clickTable}.id FROM {$this->clickTable} ORDER BY {$this->clickTable}.id DESC LIMIT 1"); //Provides current click_id value
//                        $newClickID = ($stmt[0]->id)+1; //Provides assumed-new Auto Incriment # for click_id

						for ( $i = 0; $i < count( $keywordVariables ); $i ++ ) {
							$this->wpdb->insert( $this->keywordTable, array(
								'link_id'  => $newLinkID,
								'keywords' => $keywordVariables[ $i ]
							) ); //Inserts keywords into wp_earthleylinkmgr_keywords: link_id, keywords
						}

						$event = 'done';
					}
				} else {
					$payload = 'Alias already exists.';
				}
			}
			echo json_encode( array( 'event' => $event, 'payload' => $payload ) );
			die();
		}

		function activate() {
			if ( function_exists( 'is_multisite' ) && is_multisite() ) {
				// check if it is a network activation - if so, run the activation function for each blog id
				if ( isset( $_GET['networkwide'] ) && ( $_GET['networkwide'] == 1 ) ) {
					$old_blog = $this->wpdb->blogid;
					// Get all blog ids
					$blogids = $this->wpdb->get_col( "SELECT blog_id FROM $this->wpdb->blogs" );
					foreach ( $blogids as $blog_id ) {
						switch_to_blog( $blog_id );
						$this->_activate();
					}
					switch_to_blog( $old_blog );

					return;
				}
			}
			$this->_activate();
		}

		function _activate() {
            $this->db_setup();
            $this->db_data_setup();
            $this->emailList();

			$default_options                           = array();
			$default_options['enable_keyword_to_link'] = isset( $this->options['enable_keyword_to_link'] ) ? $this->options['enable_keyword_to_link'] : "checked";
			$default_options['open_in_new_window']     = isset( $this->options['open_in_new_window'] ) ? $this->options['open_in_new_window'] : "checked";
			$default_options['use_nofollow']           = isset( $this->options['use_nofollow'] ) ? $this->options['use_nofollow'] : "checked";
			$default_options['count_clicks']           = isset( $this->options['count_clicks'] ) ? $this->options['count_clicks'] : "checked";
			$default_options['link_for_post']          = $this->options['link_for_post'] = "checked";
//			$default_options['link_for_post']          = isset( $this->options['link_for_post'] ) ? $this->options['link_for_post'] : "checked";
			$default_options['link_for_page'] = $this->options['link_for_page'] = "checked";
//			$default_options['link_for_page']          = isset( $this->options['link_for_page'] ) ? $this->options['link_for_page'] : "checked";
			$default_options['max_links']             = isset( $this->options['max_links'] ) ? $this->options['max_links'] : - 1;
			$default_options['ref_id']                = isset( $this->options['ref_id'] ) ? $this->options['ref_id'] : "";
			$default_options['max_per_paragraph']     = isset( $this->options['max_per_paragraph'] ) ? $this->options['max_per_paragraph'] : "3";
//			$default_options['post_types_enabled']    = isset( $this->options['post_types_enabled'] ) ? $this->options['post_types_enabled'] : "post";
			$default_options['link_prefix']           = isset( $this->options['link_prefix'] ) ? $this->options['link_prefix'] : "link";
			$default_options['items_per_page']        = isset( $this->options['items_per_page'] ) ? $this->options['items_per_page'] : "50";
//			$default_options['custom_font_color']     = isset( $this->options['custom_font_color'] ) ? $this->options['custom_font_color'] : "#0054a5";
//			$default_options['custom_font_family']    = isset( $this->options['custom_font_family'] ) ? $this->options['custom_font_family'] : "0";
//			$default_options['custom_font_size']      = isset( $this->options['custom_font_size'] ) ? $this->options['custom_font_size'] : "1";
//			$default_options['custom_font_size_unit'] = isset( $this->options['custom_font_size_unit'] ) ? $this->options['custom_font_size_unit'] : "em";
			$default_options['post_types_enabled'] = isset( $this->options['post_types_enabled'] ) ? $this->options['post_types_enabled'] : "post";
            $default_options['wisdom_registered_setting'] = 1; //for tracking purposes
			update_option( 'earthleylinkmgr_settings', $default_options );
		}

        function emailList(){
//            curl - X POST https://api.convertkit.com/v3/forms/<form_id>/subscribe\
//            -H "Content-Type: application/json; charset=utf-8"\
//            -d

            //sign user up to the convertkit sequence that gives them tips on using the plugin, and how to be more successful
            //todo long term switch this to an earthley API call
            $api_key = "Lg7oeNxQvDpNLNetOuBdhQ";

//          api_key - Your account API key.
//          email - Subscriber email address.

            $data = array( 'api_key' => $api_key, 'email' => get_option('admin_email') );
            //$response = wp_remote_post( 'https://api.convertkit.com/v3/forms/50f02827b4/subscribe', array( 'data' => $data ) );

            //if auto add fails, then email earthley admin
//            if($response){
//                //todo finish
//            }


//            $client = new forms( $api_key );
//            $response = $client->add( '50f02827b4', [ 'email' => get_option('admin_email') ] );

            $current_user = wp_get_current_user();
            $name = 'Earthologist - Plugin User';
            $client = new forms( $api_key );
            $form = $client->get( $name );
            $response = [];
            if( $form ) {
                $response = $client->add( $form->id, [ 'email' => $current_user->user_email ] ); //get_option('admin_email')
            }

            if( !array_key_exists('subscription', $response) ){
                //if api fails, then send plugin author a message
                wp_mail( 'customercare@earthley.com', 'New Plugin User', 'Please add '.$current_user->user_email.' to subscriber list!' );
                $response = array('steve');
            }

            //return $response;
		}

		function db_setup() {
            global $wpdb;
            $db_version      = '0.2.2';
            add_option( 'earthleylinkmgr_db_version', $db_version );
            require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
            $charset_collate = $wpdb->get_charset_collate();
            $this->linkTable = $this->wpdb->prefix . 'earthleylinkmgr_links';

            /*******************
            ***  LINKS TABLE ***
            *******************/

            $table_name = $wpdb->prefix . 'earthleylinkmgr_links';

            $sql = "CREATE TABLE $table_name (
            `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
            `link_title` varchar(150) NOT NULL,
            `link_dest` varchar(255) NOT NULL,
            `alias_link` varchar(255) NOT NULL,
            `escaped_alias_link` varchar(255) NOT NULL,
            `new_window` tinyint(4) NOT NULL DEFAULT '0',
            `no_follow` tinyint(4) NOT NULL DEFAULT '0',
            `replace_existing_links` tinyint(4) NOT NULL DEFAULT '0',
            `master_record` tinyint(4) NOT NULL DEFAULT '0',
            `active` tinyint(1) NOT NULL DEFAULT '0',
            `status` tinyint(1) NOT NULL DEFAULT '0',
            `start_date` datetime,
            `end_date` datetime,
            PRIMARY KEY  (id),
            UNIQUE KEY `UNIQUE KEYS` (`link_title`)
            ) $charset_collate;";

            dbDelta( $sql );

            /*******************
            *** CLICKS TABLE ***
            *******************/

            $table_name = $wpdb->prefix . 'earthleylinkmgr_clicks';

//            $sql = "CREATE TABLE $table_name (
//            `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
//            `link_id` int(10) NOT NULL,
//            `keyword_id` int(10) NOT NULL,
//            `post_id` int(10) NOT NULL,
//            `view_count` int(10) NOT NULL,
//            `click_count` int(10) NOT NULL,
//            `conversion_rate` decimal(10,2) NOT NULL,
//            PRIMARY KEY  (id)
//            ) $charset_collate;";

            $sql = "CREATE TABLE $table_name (
            `link_id` int(10) NOT NULL,
            `keyword_id` int(10) NOT NULL,
            `post_id` int(10) NOT NULL,
            `view_count` int(10) NOT NULL,
            `click_count` int(10) NOT NULL,
            `conversion_rate` decimal(10,2) NOT NULL,
            PRIMARY KEY  (link_id, keyword_id, post_id)
            ) $charset_collate;";

            dbDelta( $sql );

            /**********************
            ***  KEYWORDS TABLE ***
            **********************/

            $table_name = $wpdb->prefix . 'earthleylinkmgr_keywords';

            $sql = "CREATE TABLE $table_name (
            `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
            `link_id` int(10) NOT NULL,
            `keywords` varchar(150) NOT NULL,
            PRIMARY KEY  (id),
            UNIQUE KEY `UNIQUE KEYS` (`keywords`)
            ){$charset_collate};";

            dbDelta( $sql );

            //TODO add the sales table here
        }

		function deactivate() {
		    //todo remove them from subscriber list?
			if ( function_exists( 'is_multisite' ) && is_multisite() ) {
				// check if it is a network activation - if so, run the activation function for each blog id
				if ( isset( $_GET['networkwide'] ) && ( $_GET['networkwide'] == 1 ) ) {
					$old_blog = $this->wpdb->blogid;
					// Get all blog ids
					$blogids = $this->wpdb->get_col( "SELECT blog_id FROM $this->wpdb->blogs" );
					foreach ( $blogids as $blog_id ) {
						switch_to_blog( $blog_id );
						$this->_deactivate();
					}
					switch_to_blog( $old_blog );

					return;
				}
			}
			$this->_deactivate();
		}

		function _deactivate() {
		}

		function escapize( $text ) {
			$text = strip_tags( $text );
			$text = preg_replace( '/[^a-z0-9_]+/i', '_', $text );
			if ( strlen( $text ) < 1 ) {
				$text = 'link';
			};

			return $text;
		}

		function click( $token ) {
			$this->clickTable   = $this->wpdb->prefix . 'earthleylinkmgr_clicks';
			$this->linkTable    = $this->wpdb->prefix . 'earthleylinkmgr_links';
			$this->keywordTable = $this->wpdb->prefix . 'earthleylinkmgr_keywords';
			//$token              = $this->wpdb->escape( $token );
            $token              = esc_sql( $token ); //todo replaced escape
			$this->postID       = $_REQUEST['postID']; //Hacky way to keep post ID because wordpress hurts my head
			$link               = $this->wpdb->get_results( "SELECT {$this->linkTable}.id, {$this->keywordTable}.id as keyword_id FROM {$this->linkTable} JOIN {$this->keywordTable} ON {$this->keywordTable}.link_id = {$this->linkTable}.id WHERE REPLACE({$this->keywordTable}.keywords, \"'\", \" \") = '{$token}'" ); //Gets the linkID associated with the token
			$clickcnt           = $this->wpdb->get_results( "SELECT {$this->clickTable}.click_count FROM {$this->clickTable} WHERE {$this->clickTable}.keyword_id={$link[0]->keyword_id} AND {$this->clickTable}.link_id={$link[0]->id}" );
			$clickcnt           = $clickcnt[0]->click_count + 1; //todo error on this line, array offset problem?
			$this->wpdb->query( "UPDATE {$this->clickTable} SET {$this->clickTable}.click_count = $clickcnt WHERE {$this->clickTable}.post_id= {$this->postID} AND {$this->clickTable}.link_id= {$link[0]->id} AND {$this->clickTable}.keyword_id = {$link[0]->keyword_id}" ); //Updates the link to +1 in clicks
			$this->wpdb->query( "UPDATE {$this->clickTable} SET {$this->clickTable}.conversion_rate = ({$this->clickTable}.click_count/{$this->clickTable}.view_count)*100 WHERE {$this->clickTable}.post_id= {$this->postID} AND {$this->clickTable}.link_id= {$link[0]->id} AND {$this->clickTable}.keyword_id = {$link[0]->keyword_id} " ); //Updates the conversion rate on click. (seemed smsart at 330pm on a friday
		}

		function getDestination( $token ) {
			$this->linkTable    = $this->wpdb->prefix . 'earthleylinkmgr_links';
			$this->keywordTable = $this->wpdb->prefix . 'earthleylinkmgr_keywords';
			$this->ref_id       = preg_replace( "/[^a-zA-Z0-9]/", '', $this->options['ref_id'] );
			//$token              = $this->wpdb->escape( $token );
            $token              = esc_sql( $token ); //todo replaced escape

            //error_log("token: ".$token);
            //error_log("SELECT {$this->linkTable}.link_dest FROM {$this->linkTable} JOIN {$this->keywordTable} ON {$this->keywordTable}.link_id = {$this->linkTable}.id WHERE {$this->keywordTable}.keywords = '{$token}'");

			$url                = $this->wpdb->get_var( "SELECT {$this->linkTable}.link_dest FROM {$this->linkTable} JOIN {$this->keywordTable} ON {$this->keywordTable}.link_id = {$this->linkTable}.id WHERE REPLACE({$this->keywordTable}.keywords, \"'\", \" \") = '{$token}'" );
			/*
			 * Added the reference ID to the end of the main link.
			 * Also trims white-space. The end result -> earthley.com/<keyword>/?ref=$this->ref_id
			 */

			//if ref id not filled out, then leave blank
			if ( strlen( $this->ref_id ) < 1 ) {
				return $url;
			} else {
			    //make sure this is a link to earthley, and only use ref_id if it is
			    if(strpos($url, 'www.earthley.com')) {
                    return $url . "ref/{$this->ref_id}/?campaign=plugin";
                } else {
                    return $url;
                }
			}
		}

		function html2a( $html ) {
			if ( ! preg_match_all( '@
             \<\s*?(\w+)((?:\b(?:\'[^\']*\'|"[^"]*"|[^\>])*)?)\>
             ((?:(?>[^\<]*)|(?R))*)
             \<\/\s*?\\1(?:\b[^\>]*)?\>
             |\<\s*(\w+)(\b(?:\'[^\']*\'|"[^"]*"|[^\>])*)?\/?\>
             @uxis', $html = trim( $html ), $m, PREG_OFFSET_CAPTURE | PREG_SET_ORDER ) ) {
				return $html;
			}
			$i   = 0;
			$ret = array();
			foreach ( $m as $set ) {
				if ( strlen( $val = trim( substr( $html, $i, $set[0][1] - $i ) ) ) ) {
					$ret[] = $val;
				}
				$val = $set[1][1] < 0
					? array( 'tag' => strtolower( $set[4][0] ) )
					: array( 'tag' => strtolower( $set[1][0] ), 'val' => $this->html2a( $set[3][0] ) );
				if ( preg_match_all( '/(\w+)\s*(?:=\s*(?:"([^"]*)"|\'([^\']*)\'|(\w+)))?/usix', isset( $set[5] ) && $set[2][1] < 0
					? $set[5][0]
					: $set[2][0]
					, $attrs, PREG_SET_ORDER ) ) {
					foreach ( $attrs as $a ) {
						$val['attr'][ $a[1] ] = $a[ count( $a ) - 1 ];
					}
				}
				$ret[] = $val;
				$i     = $set[0][1] + strlen( $set[0][0] );
			}
			$l = strlen( $html );
			if ( $i < $l ) {
				if ( strlen( $val = trim( substr( $html, $i, $l - $i ) ) ) ) {
					$ret[] = $val;
				}
			}

			return $ret;
		}

		/*Functions by LA*/
		function getLinks() {
			if ( ! empty( $this->initialKeywords ) ) {
				$newPattern   = array();
				$allclickinfo = $this->wpdb->get_results( "
							SELECT {$this->keywordTable}.keywords, {$this->clickTable}.keyword_id, {$this->clickTable}.link_id, {$this->clickTable}.view_count, {$this->clickTable}.conversion_rate 
							FROM {$this->clickTable} 
							JOIN {$this->keywordTable} ON {$this->keywordTable}.id = {$this->clickTable}.keyword_id 
							WHERE {$this->clickTable}.post_id = {$this->postID} 
							ORDER BY {$this->clickTable}.view_count AND {$this->clickTable}.conversion_rate DESC" );
				$counter      = 0;
				if ( ! empty( $allclickinfo ) ) {
					if ( count( $allclickinfo ) < count( $this->initialKeywords ) ) {
						for ( $ix = 0; $ix < ( count( $allclickinfo ) ); $ix ++ ) {
							for ( $jx = 0; $jx < ( count( $this->initialKeywords ) ); $jx ++ ) {
								if ( $allclickinfo[ $ix ]->keywords == $this->initialKeywords[ $jx ] ) {
									unset( $this->initialKeywords[ $jx ] );
									$this->initialKeywords = array_values( $this->initialKeywords );
								}
							}
						}
						if ( count( $this->initialKeywords ) < $this->max_per_paragraph ) {
							$rand_keys = array_rand( $this->initialKeywords, ( count( $this->initialKeywords ) ) );
						} else {
							$rand_keys = array_rand( $this->initialKeywords, $this->max_per_paragraph );
						}
						for ( $lx = 0; $lx < $this->max_per_paragraph; $lx ++ ) {
							$newPattern[ $lx ] = "/\b" . $this->initialKeywords[ $rand_keys[ $lx ] ] . "\b/i";
						}
					}
				}
				if ( empty( $newPattern ) ) {
					for ( $ax = 0; $ax < count( $allclickinfo ); $ax ++ ) {
						/*
						 * NEED TO FILTER AGAINST THE KEYWORDS THAT ARE NOT IN THE CLICK TABLE
						 * THAT WAY IT CAN BE RANDOMIZED? EVERY TIME. (DIFFERENT KEYWORDS SHOW UP)
						 */
						if ( $allclickinfo[ $ax ]->view_count < $this->view_min_threshold ) {
							$keywordsNotShown[ $counter ]['keyword']          = $allclickinfo[ $ax ]->keywords;
							$keywordsNotShown[ $counter ]['keyword_id']       = $allclickinfo[ $ax ]->keyword_id;
							$keywordsNotShown[ $counter ]['view_count']       = $allclickinfo[ $ax ]->view_count;
							$keywordsNotShown[ $counter ]['conveersion_rate'] = $allclickinfo[ $ax ]->conversion_rate;
							$counter ++;
						}
					}
					if ( ( isset( $keywordsNotShown ) ) && ( count( $keywordsNotShown ) < $this->max_per_paragraph ) ) {
						for ( $lx = 0; $lx < count( $keywordsNotShown ); $lx ++ ) {
							$newPattern[ $lx ] = "/\b" . $keywordsNotShown[ $lx ]['keyword'] . "\b/i";
						}
						while ( $lx < $this->max_per_paragraph ) {
							$newPattern[ $lx ] = "/\b" . $allclickinfo[ $lx ]->keywords . "\b/i";
							$lx ++;
						}
					}
					if ( ! isset( $keywordsNotShown ) ) {
						if ( empty( $allclickinfo ) ) {
//					$rand_keys = shuffle($this->initialKeywords);
							$rand_keys = array_rand( $this->initialKeywords, $this->max_per_paragraph );
							for ( $valCount = 0; $valCount < $this->max_per_paragraph; $valCount ++ ) {
								$newPattern[ $valCount ] = "/\b" . $this->initialKeywords[ $rand_keys[ $valCount ] ] . "\b/i";
							}
						} else {
							for ( $kx = 0; $kx < $this->max_per_paragraph; $kx ++ ) {
								$newPattern[ $kx ] = "/\b" . $allclickinfo[ $kx ]->keywords . "\b/i";
							}
						}

					}

					if ( count( $keywordsNotShown ) > $this->max_per_paragraph ) {
						$rand_keys = array_rand( $keywordsNotShown, $this->max_per_paragraph );
						for ( $bx = 0; $bx < $this->max_per_paragraph; $bx ++ ) {
							$newPattern[ $bx ] = "/\b" . $keywordsNotShown[ $rand_keys[ $bx ] ]['keyword'] . "\b/i";
						}
					}

					if ( count( $keywordsNotShown ) == $this->max_per_paragraph ) {
						for ( $kx = 0; $kx < count( $keywordsNotShown ); $kx ++ ) {
							$newPattern[ $kx ] = "/\b" . $keywordsNotShown[ $kx ]['keyword'] . "\b/i";
						}
					}
				}

				usort( $newPattern, array( $this, 'reverseOrder' ) );

				return $newPattern;

			}
		}

		function getLinks2( $r ) {
			if ( ! empty( $this->initialKeywords ) ) {
				$newPattern   = array();
				$allclickinfo = $this->wpdb->get_results( "SELECT {$this->keywordTable}.keywords, {$this->clickTable}.keyword_id, {$this->clickTable}.link_id, {$this->clickTable}.view_count, {$this->clickTable}.conversion_rate FROM {$this->clickTable} JOIN {$this->keywordTable} ON {$this->keywordTable}.id = {$this->clickTable}.keyword_id WHERE {$this->clickTable}.post_id = {$this->postID} ORDER BY {$this->clickTable}.view_count AND {$this->clickTable}.conversion_rate DESC" );
				$counter      = 0;
				if ( ( ! empty( $allclickinfo ) ) && ( $this->testingShit[ $r ] != null ) ) {
					if ( count( $this->testingShit[ $r ] ) < $this->max_per_paragraph ) {
						$rand_keys = array_rand( $this->testingShit[ $r ], ( count( $this->testingShit[ $r ] ) ) );
						if ( is_array( $rand_keys ) ) {
							$string = "/\b" . $this->testingShit[ $r ][ $rand_keys[ $r ] ] . "\b/i";
						} else {
							$string = "/\b" . $this->testingShit[ $r ][ $rand_keys ] . "\b/i";
						}
						$thiscount = ( $this->max_per_paragraph - ( count( $this->testingShit[ $r ] ) ) );
						for ( $lx = 0; $lx < ( count( $this->testingShit[ $r ] ) ); $lx ++ ) {
							$newPattern[ $lx ] = $string;
						}
						for ( $hx = 0; $hx < ( $thiscount ); $hx ++ ) {
							$newPattern[ $lx ] = "/\b" . $allclickinfo[ $hx ]->keywords . "\b/i";
						}
					}
					if ( count( $this->testingShit[ $r ] ) >= $this->max_per_paragraph ) {
						$rand_keys = array_rand( $this->testingShit[ $r ], $this->max_per_paragraph );
						for ( $lx = 0; $lx < $this->max_per_paragraph; $lx ++ ) {
							$newPattern[ $lx ] = "/\b" . $this->testingShit[ $r ][ $rand_keys[ $lx ] ] . "\b/i";
						}
					}
				}
				if ( empty( $newPattern ) ) {
					if ( isset( $this->paragraphKeywords ) || ! empty( $this->paragraphKeywords ) ) {
						if ( count( $allclickinfo ) < count( $this->paragraphKeywords ) ) {
							for ( $ix = 0; $ix < ( count( $allclickinfo ) ); $ix ++ ) {
								for ( $jx = 0; $jx < ( count( $this->paragraphKeywords ) ); $jx ++ ) {
									if ( $allclickinfo[ $ix ]->keywords == $this->paragraphKeywords[ $jx ] ) {
										unset( $this->paragraphKeywords[ $jx ] );
										$this->paragraphKeywords = array_values( $this->paragraphKeywords );
									}
								}
							}
							if ( count( $this->paragraphKeywords ) < $this->max_per_paragraph ) {
								$rand_keys = array_rand( $this->paragraphKeywords, ( count( $this->paragraphKeywords ) ) );
							} else {
								$rand_keys = array_rand( $this->paragraphKeywords, $this->max_per_paragraph );
							}
							for ( $lx = 0; $lx < $this->max_per_paragraph; $lx ++ ) {
								$newPattern[ $lx ] = "/\b" . $this->paragraphKeywords[ $rand_keys[ $lx ] ] . "\b/i";
							}
						}
					} else {
						for ( $ax = 0; $ax < count( $allclickinfo ); $ax ++ ) {
							/*
							 * NEED TO FILTER AGAINST THE KEYWORDS THAT ARE NOT IN THE CLICK TABLE
							 * THAT WAY IT CAN BE RANDOMIZED? EVERY TIME. (DIFFERENT KEYWORDS SHOW UP)
							 */
							if ( $allclickinfo[ $ax ]->view_count < $this->view_min_threshold ) {
								$keywordsNotShown[ $counter ]['keyword']          = $allclickinfo[ $ax ]->keywords;
								$keywordsNotShown[ $counter ]['keyword_id']       = $allclickinfo[ $ax ]->keyword_id;
								$keywordsNotShown[ $counter ]['view_count']       = $allclickinfo[ $ax ]->view_count;
								$keywordsNotShown[ $counter ]['conveersion_rate'] = $allclickinfo[ $ax ]->conversion_rate;
								$counter ++;
							}
						}
						if ( ( isset( $keywordsNotShown ) ) && ( count( $keywordsNotShown ) < $this->max_per_paragraph ) ) {
							for ( $lx = 0; $lx < count( $keywordsNotShown ); $lx ++ ) {
								$newPattern[ $lx ] = "/\b" . $keywordsNotShown[ $lx ]['keyword'] . "\b/i";
							}
							while ( $lx < $this->max_per_paragraph ) {
								$newPattern[ $lx ] = "/\b" . $allclickinfo[ $lx ]->keywords . "\b/i";
								$lx ++;
							}
						}
						if ( ! isset( $keywordsNotShown ) ) {
							if ( empty( $allclickinfo ) ) {
								if ( count( $this->initialKeywords ) < $this->max_per_paragraph ) {
									$rand_keys = array_rand( $this->initialKeywords, ( count( $this->initialKeywords ) ) );
								} else {
									$rand_keys = array_rand( $this->initialKeywords, $this->max_per_paragraph );
								}
								for ( $valCount = 0; $valCount < $this->max_per_paragraph; $valCount ++ ) {
									$newPattern[ $valCount ] = "/\b" . $this->initialKeywords[ $rand_keys[ $valCount ] ] . "\b/i";
								}
							} else {
								for ( $kx = 0; $kx < $this->max_per_paragraph; $kx ++ ) {
									$newPattern[ $kx ] = "/\b" . $allclickinfo[ $kx ]->keywords . "\b/i";
								}
							}

						}

						if ( count( $keywordsNotShown ) > $this->max_per_paragraph ) {
							$rand_keys = array_rand( $keywordsNotShown, $this->max_per_paragraph );
							for ( $bx = 0; $bx < $this->max_per_paragraph; $bx ++ ) {
								$newPattern[ $bx ] = "/\b" . $keywordsNotShown[ $rand_keys[ $bx ] ]['keyword'] . "\b/i";
							}
						}

						if ( count( $keywordsNotShown ) == $this->max_per_paragraph ) {
							for ( $kx = 0; $kx < count( $keywordsNotShown ); $kx ++ ) {
								$newPattern[ $kx ] = "/\b" . $keywordsNotShown[ $kx ]['keyword'] . "\b/i";
							}
						}
					}

				}
//				unset($this->paragraphKeywords);
				usort( $newPattern, array( $this, 'reverseOrder' ) );
				$this->counterVar ++;

				return $newPattern;

			}
		}

        function getLinks3( $r ) {
            if ( ! empty( $this->paragraphKeywords ) ) {
                $newPattern   = array();
                $allclickinfo = $this->wpdb->get_results( "SELECT {$this->keywordTable}.keywords, {$this->clickTable}.keyword_id, {$this->clickTable}.link_id, {$this->clickTable}.view_count, {$this->clickTable}.conversion_rate FROM {$this->clickTable} JOIN {$this->keywordTable} ON {$this->keywordTable}.id = {$this->clickTable}.keyword_id WHERE {$this->clickTable}.post_id = {$this->postID} ORDER BY {$this->clickTable}.conversion_rate DESC" );

                /********************
                 *** SELECT MAtRIX ***
                 ********************/

                /*
                TODO pick sales first
                1) pick if keyword has been viewed less then 100 times
                2) pick based on highest converting keyword
                */

//				Need to figure out if we have keywords under 100 views
                for ( $i = 0; $i < count( $allclickinfo ); $i ++ ) {
                    if ( $allclickinfo[ $i ]->view_count < $this->view_min_threshold ) {
                        $keywordsNotShown[ $i ] = $allclickinfo[ $i ];
                        $keywordsName[$i] = $allclickinfo[$i]->keywords;
                    } else {
                        $bigkeywordsName[$i] = $allclickinfo[$i]->keywords;
                        $bigconversionRate[$i] = $allclickinfo[$i]->conversion_rate;
                    }
                }

                if ( isset( $keywordsNotShown ) ) {
                    $keywordsNotShown = array_values( $keywordsNotShown );
                    $paragraphKeywords = array_map('strtolower', $this->paragraphKeywords);
                    $keywordsPGDB = array_values(array_intersect($keywordsName, $paragraphKeywords));
                    $insertedKeywordsCount = 0;
                    $newcount = 0;

                    // if we have more keywords < 100 than max per ppg
                    // and the keywords in the ppg are among them
                    // pick from the ppg keywords set
                    if ( ( count( $keywordsNotShown ) >= $this->max_per_paragraph ) && empty( $newPattern ) ) {
                        // randomly choose the keywords that are under the view_threshold
                        if (count($keywordsPGDB) > 0){
                            $rand_keys = array_rand( $keywordsPGDB, count($keywordsPGDB) );
                            for ( $lx = 0; $lx < $this->max_per_paragraph; $lx ++ ) {
                                if (count($keywordsPGDB) >= $this->max_per_paragraph) {
                                    $newPattern[ $lx ] = "/\b" . $keywordsPGDB[ $rand_keys[ $lx ] ] . "\b/i";
                                }
                                if (count($keywordsPGDB) < $this->max_per_paragraph) {

                                    // if we run out of keywords < 100, choose the highest converting
                                    if ($this->max_per_paragraph - (count($keywordsPGDB)) == $insertedKeywordsCount){
                                        $newPattern[ $i ] = "/\b" . $allclickinfo[ $newcount ]->keywords . "\b/i";
                                        $newcount++;
                                    } else {
                                        // otherwise choose the remaining keywords < 100
                                        $newPattern[ $lx ] = "/\b" . $keywordsPGDB[  $lx ] . "\b/i";
                                    }

                                    $insertedKeywordsCount++;
                                }
                            }
                        }

                    }

                    // if we have less keywords < 100 than max per ppg
                    // and the keywords in the ppg are among them
                    // pick from the ppg keywords set, then pick the highest converting
                    if ( ( count( $keywordsNotShown ) < $this->max_per_paragraph ) && ( empty( $newPattern ) ) ) {
                        // choose all the keywords that are under the view_threshold, then pick highest converting keyword
                        if (count($keywordsPGDB) > 0) {
                            $rand_keys = array_rand( $keywordsPGDB, ( count( $keywordsPGDB ) ) );
                            if ( is_array( $rand_keys ) ) {
                                $string = "/\b" . $keywordsPGDB[ $rand_keys[ $r ] ] . "\b/i";
                            } else {
                                $string = "/\b" . $keywordsPGDB[ $rand_keys ] . "\b/i";
                            }
                            $thiscount = ( $this->max_per_paragraph - ( count( $keywordsPGDB ) ) );
                            for ( $lx = 0; $lx < ( count( $keywordsPGDB ) ); $lx ++ ) {
                                $newPattern[ $lx ] = $string;
                            }
                            for ( $hx = $lx; $hx <= ( $thiscount ); $hx ++ ) {
                                $newPattern[ $hx ] = "/\b" . $allclickinfo[ $hx ]->keywords . "\b/i";
                            }
                        }
                    }
                } else {
                    // if there are no keywords that are under the view threshold, pick highest converting
                    $keywordsPGDB = array_values(array_intersect($bigkeywordsName, $this->paragraphKeywords));
                    for ($i=0; $i < count($keywordsPGDB); $i++) {
                        if (in_array($keywordsPGDB[$i], $bigkeywordsName)) {
                            $key = array_search($keywordsPGDB[$i], $bigkeywordsName);
                            $newClickInfo[$i] = $allclickinfo[$key];
                        }
                    }
                    // can't tell if we NEED to sort again, but just in case i'll leave this here...
                    /*$newClickInfo = json_decode(json_encode($newClickInfo), True);
                    foreach ($newClickInfo as $key => $row) {
                        // because sorting strings is retarded..
                        $newClickInfo[$key]['conversion_rate'] = floatval($newClickInfo[$key]['conversion_rate']);
                    }
                    array_multisort(array_column($newClickInfo, 4), SORT_DESC, $newClickInfo);*/

                    for ( $i = 0; $i < $this->max_per_paragraph; $i ++ ) {
                        $newPattern[ $i ] = "/\b" . $newClickInfo[$i]->keywords . "\b/i";

                        // if you use the sorted version you MUST use this call below
                        //$newPattern[ $i ] = "/\b" . $newClickInfo[$i]['keywords'] . "\b/i";
                    }
                }
                usort( $newPattern, array( $this, 'reverseOrder' ) );
                $this->counterVar ++;

                return $newPattern;
            }
        }

		function getLinks4( $r ) {
//		    echo "getLinks4: ".$r."<br>";

            //this->paragraphKeywords will contain all the links in the given paragraph(aka $r)
			if ( ! empty( $this->paragraphKeywords ) ) {
                /********************
                *** SET VARIABLES ***
                ********************/

				$newPattern   = array();

				//get all the views/clicks/conversion rates for the links on the page (may contain links not in this paragraph,
                // and might be missing links that haven't ever been viewed before)
				$allclickinfo = $this->wpdb->get_results( "SELECT {$this->keywordTable}.keywords, {$this->clickTable}.keyword_id, {$this->clickTable}.link_id, {$this->clickTable}.view_count, {$this->clickTable}.conversion_rate FROM {$this->clickTable} JOIN {$this->keywordTable} ON {$this->keywordTable}.id = {$this->clickTable}.keyword_id WHERE {$this->clickTable}.post_id = {$this->postID} ORDER BY {$this->clickTable}.conversion_rate DESC" );

//                echo "paragraphKeywords: <pre>";
//                print_r($this->paragraphKeywords);
//                echo "</pre>";
//
//				echo "allclick: <pre>";
//				print_r($allclickinfo);
//				echo "</pre>";

				/*
                testing

				SELECT `" . $this->wpdb->prefix . "earthleylinkmgr_clicks`.*,  `" . $this->wpdb->prefix . "earthleylinkmgr_keywords`.`keywords`
                FROM `" . $this->wpdb->prefix . "earthleylinkmgr_clicks`
                JOIN `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` ON `" . $this->wpdb->prefix . "earthleylinkmgr_keywords`.`id` = `" . $this->wpdb->prefix . "earthleylinkmgr_clicks`.`keyword_id`
                WHERE `post_id` = 3482 ORDER BY `conversion_rate`  DESC

				*/

                //set maximum links to get
                if(count($this->paragraphKeywords) < $this->max_per_paragraph){
                    $maxLinkCount = count($this->paragraphKeywords);
                } else {
                    $maxLinkCount = $this->max_per_paragraph;
                }

                //create array for processing
                $keywordsWithConversion = [];
                for ( $i = 0; $i < count($this->paragraphKeywords); $i ++ ) {
                    $found = false;
                    $keywordsWithConversion[$i]['keywords'] = $this->paragraphKeywords[$i];

                    //find the view count and conversion rates
                    for ( $j = 0; $j < count($allclickinfo); $j ++ ) {
                        if($this->paragraphKeywords[$i] == $allclickinfo[$j]->keywords){
                            $keywordsWithConversion[$i]['view_count'] = $allclickinfo[$j]->view_count;
                            $keywordsWithConversion[$i]['conversion_rate'] = $allclickinfo[$j]->conversion_rate;
                            $found = true;
                        }
                    }

                    //if keyword isn't in db yet, then use 0's
                    if($found == false) {
                        $keywordsWithConversion[$i]['view_count'] = 0;
                        $keywordsWithConversion[$i]['conversion_rate'] = 0;
                    }
                }

//                echo "KWC: <pre>";
//                print_r($keywordsWithConversion);
//                echo "</pre>";

                /********************
                 *** DECISION TREE ***
                 ********************/

                /*
                pick links based on the following criteria:
                TODO pick sales first
                1) pick keyword (at random) if it has been viewed less then 100 times
                2) pick based on highest converting keyword (once they are over 100 views)
                */

                //get keywords
                for ( $i = 0; $i < $maxLinkCount; $i ++ ) {
                    //if there are still keywords to pull from, then continue
                    if(count($keywordsWithConversion) > 0){
                        //determine if there are any keywords with < view_min_threshold (currently set to 100)

                        //PHP7 only - BLT 5/22/2019
//                        usort($keywordsWithConversion, function($a, $b) {
//                            return $a['view_count'] <=> $b['view_count'];
//                        });
                          usort($keywordsWithConversion, function($a, $b) {
                              if ($a == $b) {
                                  return 0;
                              }
                              return ($a['view_count'] < $b['view_count']) ? -1 : 1;
                          });

//                        echo "KWC view_count: <pre>";
//                        print_r($keywordsWithConversion);
//                        echo "</pre>";

                        //if the least viewed record is less then 100, then select it
                        if($keywordsWithConversion[0]['view_count'] < 100){
                            //$newPattern[ $i ] = "/\b" . $keywordsWithConversion[0]['keywords'] . "\b/i";
                            //new pattern  - blt 10/20/18
/*                            $newPattern[ $i ] = '#(?!<.*?)(\b'.$keywordsWithConversion[0]['keywords'].'\b)(?![^<>]*?>)#si';*/
                            $newPattern[ $i ] = '#(?!<a[^>]*?>)(\b'.$keywordsWithConversion[0]['keywords'].'\b)(?![^<]*?<\/a>)#si';
                            unset($keywordsWithConversion[0]);
                        }
                        //then pick based on conversation rate
                        else {
                            //PHP7 only - BLT 5/22/2019
//                            usort($keywordsWithConversion, function($a, $b) {
//                                return $a['conversion_rate'] <=> $b['conversion_rate'];
//                            });

                            usort($keywordsWithConversion, function($a, $b) {
                                if($a == $b) {
                                    return 0;
                                }
                                return ($a['conversion_rate'] < $b['conversion_rate']) ? -1 : 1;
                            });

//                            echo "KWC conversion: <pre>";
//                            print_r($keywordsWithConversion);
//                            echo "</pre>";

                            //if the least viewed record is less then 100, then select it
                            $maxKey = count($keywordsWithConversion) - 1;
                            //$newPattern[ $i ] = "/\b" . $keywordsWithConversion[$maxKey]['keywords'] . "\b/i";
                            //new pattern  - blt 10/20/18
/*                            $newPattern[ $i ] = '#(?!<.*?)(\b'.$keywordsWithConversion[$maxKey]['keywords'].'\b)(?![^<>]*?>)#si';*/
                            $newPattern[ $i ] = '#(?!<a[^>]*?>)(\b'.$keywordsWithConversion[$maxKey]['keywords'].'\b)(?![^<]*?<\/a>)#si';
                            unset($keywordsWithConversion[$maxKey]);
                        }
                    }
                }

                if(!array_key_exists('counterVar', $this)){
                    $this->counterVar = 1;
                } else {
                    $this->counterVar++;
                }

//                echo "newpattern: <pre>";
//                print_r($newPattern);
//                echo "</pre>";

				return $newPattern;

			}
		}

		function reverseOrder( $a, $b ) {
			return strlen( $b ) - strlen( $a );
		}

		function updateViewCount() {
			foreach ( $this->updateKeyword as $key => $value ) {
				$keywordName = strtolower( str_replace( array( '/\b', '\b/i' ), '', $value ) );
				if ( $keywordName != null ) {
					$stmt      = $this->wpdb->get_results( "SELECT {$this->keywordTable}.id, {$this->keywordTable}.link_id, {$this->keywordTable}.keywords FROM {$this->keywordTable} WHERE {$this->keywordTable}.keywords = '".str_replace('\'', '\\\'',$keywordName)."'" );

//					echo "sql: "."SELECT {$this->keywordTable}.id, {$this->keywordTable}.link_id, {$this->keywordTable}.keywords FROM {$this->keywordTable} WHERE {$this->keywordTable}.keywords = '{$keywordName}'"."<br>";
//
//					echo "<pre>";
//					print_r($stmt);
//					echo "</pre>";

					$keywordID = (int) $stmt[0]->id;
					$linkID    = (int) $stmt[0]->link_id;
					unset( $stmt );
					$stmt       = $this->wpdb->get_results( "SELECT {$this->clickTable}.view_count, {$this->clickTable}.click_count FROM {$this->clickTable} WHERE {$this->clickTable}.post_id = {$this->postID} AND {$this->clickTable}.link_id = {$linkID} AND {$this->clickTable}.keyword_id = {$keywordID}" );

//					error_log(print_r($stmt, true));
//					error_log(count($stmt));

					if(count($stmt)) {
                        $clickCount = (int)$stmt[0]->click_count;
                        //					$count = 1;
                        $count = (int)$stmt[0]->view_count + 1;
                        //					if($count > 1) {$count = $count-1;}
                    } else {
                        $clickCount = 0;
                        $count = 1;
                    }

					if ( $clickCount == 0 ) {
						$conversionRate = 0.00;
					} else {
						$conversionRate = ( $clickCount / $count ) * 100;
					}
//					$stmt = $this->wpdb->query( "UPDATE {$this->clickTable} SET {$this->clickTable}.view_count = {$this->clickTable}.view_count+{$count}, {$this->clickTable}.conversion_rate= {$this->clickTable}.click_count/{$this->clickTable}.view_count WHERE {$this->clickTable}.post_id= {$this->postID} AND {$this->clickTable}.link_id= {$linkID} AND {$this->clickTable}.keyword_id= {$keywordID}" );
					$stmt = $this->wpdb->update(
						"{$this->clickTable}",
						array(
							"view_count"      => $count,
							"conversion_rate" => $conversionRate
						),
						array(
							"post_id"    => $this->postID,
							"link_id"    => $linkID,
							"keyword_id" => $keywordID
						) );

                    //error_log(print_r($stmt, true));

					if ( $stmt == 0 ) {
                        //todo insert
                        error_log("insert 1 ({$this->postID}) - shouldn't happen");
//						$this->wpdb->insert( $this->clickTable, array(
//							"link_id"         => $linkID,
//							"post_id"         => $this->postID,
//							"keyword_id"      => $keywordID,
//							"view_count"      => $count,
//							"click_count"     => 0,
//							"conversion_rate" => $conversionRate
//						) );
					}
//					$this->replacement_link_info[ $keywordName ]['count'] = $count;
				}
			}
		}

		function transformKeywords( $originalContent ) {
			$x            = $this->currentparagraph;
			$contentArray = $originalContent;
			if ( ! empty( $this->newPattern ) ) {
				foreach ( $this->newPattern as $np ) {
					$contentArray = preg_replace_callback( $np, array( $this, "keyword2link" ), $contentArray );
				}
				$this->contentDiff( $originalContent, $contentArray );

				return $contentArray;
			}
		}

		function transformKeywords2( $pTagSeperatedContent, $originalContent, $r ) {
			$x            = $r;
			$contentArray = $pTagSeperatedContent;
			if ( ! empty( $this->testingLinks ) ) {
                if ( ! empty( $this->testingLinks[$x] ) ) {
                    $count = count($this->testingLinks[$x]);
                } else {
                    $count = 0;
                }

                for ($i = 0; $i < $count; $i++) {
                    $contentArray = preg_replace_callback($this->testingLinks[$x][$i], array($this, "keyword2link"), $contentArray);
                }
                $this->contentDiff($pTagSeperatedContent, $contentArray);

				return $contentArray;
			}
		}

		function contentDiff( $originalContent, $newContent ) {
			$originalContentArray = explode( " ", $originalContent );
			$newContentArray      = explode( " ", $newContent );

			if ( array_diff( $originalContentArray, $newContentArray ) ) {
				$this->updateViewCount();
				unset( $this->updateKeyword );
			}
		}

		function splitWordsInParagraph( $contentArray ) {
			for ( $x = 0; $x < ( count( $contentArray ) ); $x ++ ) {
				$this->currentparagraph = $x;
				$wordcounter            = 0;
				$splitwords             = preg_split( "/\s/", $contentArray[ $x ] );
			}
		}

		function extractKeywords( $result ) {
			foreach ( $result as $row ) {
				if ( empty( $row->keywords ) ) {
					continue;
				}
				$keywords          = explode( ', ', $row->keywords );
				$keywords          = array_unique( $keywords );
				$links             = '';
				$patterns          = '';
				$max_links         = is_numeric( $this->options['max_links'] ) ? $this->options['max_links'] : - 1;
				$max_per_paragraph = is_numeric( $this->options['max_per_paragraph'] ) ? $this->options['max_per_paragraph'] : - 1;
				usort( $keywords, array( $this, 'reverseOrder' ) );
			}
		}

		function generateLinks( $stmt ) {
			global $wp_rewrite;
			for ( $j = 0; $j < count( $stmt ); $j ++ ) {
				$keywords[] = $stmt[ $j ]->keywords;
				if ( $wp_rewrite->using_mod_rewrite_permalinks() ) {
					$url[ $j ] = trailingslashit( $this->host ) .
					             ( $this->options['link_prefix'] ? ( trailingslashit( $this->escapize( $this->options['link_prefix'] ) ) ) : "link/" ) .
					             trailingslashit( $this->escapize( $keywords[ $j ] ) );
				} else {
//					$url = $this->host . '?link_mgr_token=' . $this->escapize( str_replace( ' ', '', $row->alias_link ) );
					continue;
				}
				$a[ $keywords[ $j ] ]['link'] = ' <a class="earthley_link_style" ';
				$a[ $keywords[ $j ] ]['link'] .= ' rel="nofollow" ';
				$a[ $keywords[ $j ] ]['link'] .= ' target="_blank" ';
				$a[ $keywords[ $j ] ]['link'] .= ' href="' . $url[ $j ] . '?postID=' . $this->postID . '">';
			}

			return $a;
		}

		function generateKeywords( $result, $row, $keywords, $a ) {
			for ( $i = 0; $i < count( $result ); $i ++ ) {
				$stmt = $this->wpdb->get_results( "SELECT {$this->keywordTable}.keywords FROM {$this->keywordTable} WHERE link_id = {$result[$i]->id}" );
				$this->generateLinks( $stmt, $row );

				$result[ $i ]->keywords              = implode( ", ", $keywords );
				$this->link_map_for_existing_links[] = array( 'url' => $a, 'words' => $keywords );
				unset( $keywords );
				unset( $a );
			}
		}

		function obtainAllKeywords() {
			$result = $this->wpdb->get_results( "SELECT {$this->keywordTable}.keywords FROM {$this->keywordTable}" );

			return $result;
		}

		function findInitialKeywords( $result, $content ) {
			$this->initialCounter = 0;
			foreach ( $result as $value ) {
				//$pattern        = "/\b" . $value->keywords . "\b/i";

				//new pattern  - blt 10/20/18
/*                $pattern      = '#(?!<.*?)(\b'.$value->keywords.'\b)(?![^<>]*?>)#si'; //todo this is still replacing inside of links*/
                $pattern      = '#(?!<a[^>]*?>)(\b'.$value->keywords.'\b)(?![^<]*?<\/a>)#si';

//                echo "<pre>";
//				print_r($value->keywords);
//				echo "</pre>";

                //original
                $link_patterns  = '/(<a\s*'; // Start of anchor tag
                $link_patterns .= '(.*?)\s*'; // Any attributes or spaces that may or may not exist
                $link_patterns .= 'href=[\'"]+?\s*(?P<link>\S+)\s*[\'"]+?'; // Grab the link
                $link_patterns .= '\s*(.*?)\s*>\s*'; // Any attributes or spaces that may or may not exist before closing tag
                $link_patterns .= '(?P<name>(.*?)\S+)'; // Grab the name
                $link_patterns .= '\s*<\/a>)/i'; // Any number of spaces between the closing anchor tag (case insensitive)

				$contentToCheck = preg_replace_callback( $pattern, array(
					$this,
					"newKeyword2link"
				), $content );
			}

			return $this->initialKeywords;
		}

		function findParagraphKeywords( $content ) {
//		    echo "initialKeys:<pre>";
//		    print_r($this->initialKeywords);
//		    echo "</pre>";

//            echo "content:<pre>";
//            print_r($content);
//            echo "</pre>";

			$this->initialCounter = 0;
			foreach ( $this->initialKeywords as $value ) {
				//$pattern = "/\b" . $value . "\b/i";
                //new pattern  - blt 10/20/18
/*                $pattern      = '#(?!<.*?)(\b'.$value.'\b)(?![^<>]*?>)#si';*/

//				echo "value: ".$value."<br>";
//                echo "strpos: ".strpos( $content, $value )."<br>";

				if ( strpos( strtolower($content), $value ) !== false ) {
					$this->paragraphKeywords[ $this->initialCounter ] = $value;
					$this->initialCounter ++;
				}
			}

			// find out if keyword FOR THIS PAGE is in click table. if not, add it with 0 vals
			// keyword_id, link_id, post_id = $this->postID, view_count=0, click_count=0, conversion_rate=0
			$result = $this->wpdb->get_results( "
							SELECT {$this->keywordTable}.keywords, {$this->clickTable}.keyword_id, {$this->clickTable}.link_id, {$this->clickTable}.view_count, {$this->clickTable}.click_count, {$this->clickTable}.conversion_rate 
							FROM {$this->clickTable} 
							JOIN {$this->keywordTable} ON {$this->keywordTable}.id = {$this->clickTable}.keyword_id 
							WHERE {$this->clickTable}.post_id = {$this->postID}" );

//			error_log("
//							SELECT {$this->keywordTable}.keywords, {$this->clickTable}.keyword_id, {$this->clickTable}.link_id, {$this->clickTable}.view_count, {$this->clickTable}.click_count, {$this->clickTable}.conversion_rate
//							FROM {$this->clickTable}
//							JOIN {$this->keywordTable} ON {$this->keywordTable}.id = {$this->clickTable}.keyword_id
//							WHERE {$this->clickTable}.post_id = {$this->postID}");
//			error_log(print_r($result, true));


//            echo "result:<pre>";
//            print_r($result);
//            echo "</pre>";

			if (!empty($result)){
				for ($i=0; $i< count($result); $i++) {
					$keywordsInDB[$i] = $result[$i]->keywords;
				}
				$difference = array_merge(array_diff($this->initialKeywords,$keywordsInDB),array_diff($keywordsInDB,$this->initialKeywords));

//                echo "diff:<pre>";
//                print_r($difference);
//                echo "</pre>";

				for ($i=0; $i< count($difference); $i++) {
					// for every keyword found in paragraph
					// test to see if it is a keyword already in the DB
					$keywordID = $this->wpdb->get_var("SELECT wp_earthleylinkmgr_keywords.id FROM wp_earthleylinkmgr_keywords WHERE wp_earthleylinkmgr_keywords.keywords = '{$value}'");
					$linkID = $this->wpdb->get_var("SELECT wp_earthleylinkmgr_keywords.link_id FROM wp_earthleylinkmgr_keywords WHERE wp_earthleylinkmgr_keywords.keywords = '{$value}'");

					//error_log("SELECT wp_earthleylinkmgr_keywords.id FROM wp_earthleylinkmgr_keywords WHERE wp_earthleylinkmgr_keywords.keywords = '{$value}'");
					//error_log("SELECT wp_earthleylinkmgr_keywords.link_id FROM wp_earthleylinkmgr_keywords WHERE wp_earthleylinkmgr_keywords.keywords = '{$value}'");

                    //todo insert
                    $this->wpdb->query("INSERT IGNORE INTO `".$this->clickTable."` (`keyword_id`, `link_id`, `post_id`, `view_count`,`click_count`, `conversion_rate`) VALUES (".$keywordID.", ".$linkID.", ".$this->postID.", 0, 0, 0.00)");

                    //error_log("insert 2 - $this->postID");
// 					$this->wpdb->insert( $this->clickTable, array(
// 						'keyword_id'  => $keywordID,
// 						'link_id' => $linkID,
// 						'post_id' => $this->postID,
// 						'view_count' => '0',
// 						'click_count' => '0',
// 						'conversion_rate' => '0.00'
// 					) );
				}
			} elseif (empty($result)) {
			    //error_log("in here");
//                echo "in here<br>";

				for ($i=0; $i < count($this->initialKeywords); $i++) {
					//if there is nothing in the db, add them all FOR THIS PAGE
					$insertKeyword = esc_sql($this->initialKeywords[$i]);
					$keywordID = $this->wpdb->get_var("SELECT {$this->keywordTable}.id FROM {$this->keywordTable} WHERE {$this->keywordTable}.keywords = '{$insertKeyword}'");
					$linkID = $this->wpdb->get_var("SELECT {$this->keywordTable}.link_id FROM {$this->keywordTable} WHERE {$this->keywordTable}.keywords = '{$insertKeyword}'");

                    //todo insert
                    $this->wpdb->query("INSERT IGNORE INTO `".$this->clickTable."` (`keyword_id`, `link_id`, `post_id`, `view_count`,`click_count`, `conversion_rate`) VALUES (".$keywordID.", ".$linkID.", ".$this->postID.", 0, 0, 0.00)");

                    //error_log("insert 3 - $this->postID");
// 					$this->wpdb->insert( $this->clickTable, array(
// 						'keyword_id'  => $keywordID,
// 						'link_id' => $linkID,
// 						'post_id' => $this->postID,
// 						'view_count' => '0',
// 						'click_count' => '0',
// 						'conversion_rate' => '0.00'
// 					) );
				}
			}

            if ( ! array_key_exists( 'paragraphKeywords', $this ) ) {
                return array();

            } else {
                return $this->paragraphKeywords;
            }
		}

		function newKeyword2link( $matches ) {
//            echo "matches<pre>";
//            print_r($matches);
//            echo "</pre>";

			if ( empty( $matches[0] ) ) {
				return "";
			}
			$lword = strtolower($matches[0]);
            //$lword = $matches[0];

//			echo "lword: ".$lword."<br>";
//
//			echo "count before:".$this->replacement_link_info[$lword]['count']."<br>";
////            echo "2:".$this->replacement_link_info["'".$lword."'"]['count']."<br>";
//			echo "link_info<pre>";
//			print_r($this->replacement_link_info);
//			echo "</pre>";

// original LA code
//			if ( ! $this->replacement_link_info[ $lword ]['count'] ) {
//				$this->initialKeywords[ $this->initialCounter ] = $lword;
//				$this->replacement_link_info[ $lword ]['count'] = $this->replacement_link_info[ $lword ]['count'] + 1;
//				$this->initialCounter ++;
//				echo "<br>did LA code<br>";
//			}

//            echo "count after:".$this->replacement_link_info[$lword]['count']."<br>";

			//new code - blt 10/16/18
            if ( ! array_key_exists($lword, $this->replacement_link_info) ) {
                $this->initialKeywords[$this->initialCounter] = $lword;
                $this->replacement_link_info[$lword]['count'] = 1; //$this->replacement_link_info[$lword]['count'] + 1;
                $this->initialCounter++;
            }


//            } else {
//                $this->initialKeywords[ $this->initialCounter ] = $lword;
//                $this->replacement_link_info[ $lword ]['count'] = 1;
//                $this->initialCounter ++;
//            }

//            if ( array_key_exists($lword, $this->replacement_link_info) ) {
//                $this->initialKeywords[ $this->initialCounter ] = $lword;
//                $this->replacement_link_info[ $lword ]['count'] = $this->replacement_link_info[ $lword ]['count'] + 1;
//                $this->initialCounter ++;
//            } else {
//                $this->initialKeywords[ $this->initialCounter ] = $lword;
//                $this->replacement_link_info[ $lword ]['count'] = 1;
//                $this->initialCounter ++;
//            }

			return "";
		}

		function newKeyword2linkParagraph( $matches ) {
//			if ( empty( $matches[0] ) ) {
//				return "";
//			}
//			$lword = $matches[0];
//			if ( ! $this->new_replacement_link_info[ $lword ]['count'] ) {
//				$this->paragraphKeywords[ $this->initialCounter ]   = $lword;
//				$this->new_replacement_link_info[ $lword ]['count'] = $this->replacement_link_info[ $lword ]['count'] + 1;
//				$this->initialCounter ++;
//			}
//
//			return "";
		}

		function seperateByParagraph( $content ) {
		    //TODO currently this breaks the content into blocks of 70 words (not necessarily based on logical paragraphs of content
			$part               = array();
			$count              = 70; // this is what hell looks like...
			$contentByParagraph = wpautop( $content );
			for ( $i = 0; $i < strlen( $contentByParagraph ); $i ++ ) {
				$part[ $i ]         = $this->extractWords( $contentByParagraph, $count );
				$contentByParagraph = explode( ' ', $contentByParagraph );
				$contentByParagraph = $this->cleanUp( $count, $contentByParagraph );
				$contentByParagraph = array_values( $contentByParagraph );
				$contentByParagraph = implode( ' ', $contentByParagraph );
			}

			return $part;
		}

		function seperateByParagraphOriginal( $content ) {
			$contentArray       = array();
			$contentByParagraph = wpautop( $content );
			preg_match_all( '#<p>(.+?)</p>#', $contentByParagraph, $parts );
			$temp = '';
			$ixx  = 0;
			foreach ( $parts[0] as $part ) {
				if ( strlen( $temp . $part ) > 200 ) {
					$contentArray[ $ixx ] = $temp . $part;
					$temp                 = '';
					$ixx ++;
				} else {
					$temp = $temp . $part;
				}
			}

			return $contentArray;
		}

		function getWords( $sentence, $count ) {
			preg_match( "/(?:\w+(?:\W+|$)){0,$count}/", $sentence, $matches );

			return $matches[0];
		}

		function cleanUp( $pos, $contentByParagraph ) {
			for ( $j = 0; $j < $pos; $j ++ ) {
				unset( $contentByParagraph[ $j ] );
			}

			return $contentByParagraph;
		}

		function extractWords( $string, $count ) {
			$original_string = $string;
			$words           = explode( ' ', $original_string );

			if ( count( $words ) > $count ) {
				$words  = array_slice( $words, 0, $count );
				$string = implode( ' ', $words );
			}

			return $string;
		}

		function updateDefaults() {

		}

		function findPostID() {
			$postParent = $this->wpdb->get_var("SELECT wp_posts.post_parent FROM wp_posts WHERE wp_posts.ID = {$this->postID}");
			if ($postParent == 0) {
				$postType = $this->wpdb->get_var("SELECT wp_posts.post_type FROM wp_posts WHERE wp_posts.ID = {$this->postID}");
			} else {
				$postType = $this->wpdb->get_var( "SELECT wp_posts.post_type FROM wp_posts WHERE wp_posts.ID = {$postParent}" );
			}

			return $postType;
		}

		function custom_meta_box_markup($object)
		{
			wp_nonce_field(basename(__FILE__), "meta-box-nonce");

			?>
			<div>
				<label for="meta-box-text">Text</label>
				<input name="meta-box-text" type="text" value="<?php echo get_post_meta($object->ID, "meta-box-text", true); ?>">

				<br>

				<label for="meta-box-dropdown">Dropdown</label>
				<select name="meta-box-dropdown">
					<?php
					$option_values = array(1, 2, 3);

					foreach($option_values as $key => $value)
					{
						if($value == get_post_meta($object->ID, "meta-box-dropdown", true))
						{
							?>
							<option selected><?php echo $value; ?></option>
							<?php
						}
						else
						{
							?>
							<option><?php echo $value; ?></option>
							<?php
						}
					}
					?>
				</select>

				<br>

				<label for="meta-box-checkbox">Check Box</label>
				<?php
				$checkbox_value = get_post_meta($object->ID, "meta-box-checkbox", true);

				if($checkbox_value == "")
				{
					?>
					<input name="meta-box-checkbox" type="checkbox" value="true">
					<?php
				}
				else if($checkbox_value == "true")
				{
					?>
					<input name="meta-box-checkbox" type="checkbox" value="true" checked>
					<?php
				}
				?>
			</div>
			<?php
		}

		function add_custom_meta_box()
		{
			add_meta_box("demo-meta-box", "Custom Meta Box", "custom_meta_box_markup", "post", "side", "high", null);
		}

		function save_custom_meta_box($post_id, $post, $update)
		{
			if (!isset($_POST["meta-box-nonce"]) || !wp_verify_nonce($_POST["meta-box-nonce"], basename(__FILE__)))
				return $post_id;

			if(!current_user_can("edit_post", $post_id))
				return $post_id;

			if(defined("DOING_AUTOSAVE") && DOING_AUTOSAVE)
				return $post_id;

			$slug = "post";
			if($slug != $post->post_type)
				return $post_id;

			$meta_box_text_value = "";
			$meta_box_dropdown_value = "";
			$meta_box_checkbox_value = "";

			if(isset($_POST["meta-box-text"]))
			{
				$meta_box_text_value = $_POST["meta-box-text"];
			}
			update_post_meta($post_id, "meta-box-text", $meta_box_text_value);

			if(isset($_POST["meta-box-dropdown"]))
			{
				$meta_box_dropdown_value = $_POST["meta-box-dropdown"];
			}
			update_post_meta($post_id, "meta-box-dropdown", $meta_box_dropdown_value);

			if(isset($_POST["meta-box-checkbox"]))
			{
				$meta_box_checkbox_value = $_POST["meta-box-checkbox"];
			}
			update_post_meta($post_id, "meta-box-checkbox", $meta_box_checkbox_value);
		}

		function custom_metabox() {
			add_meta_box("custom_metabox_01", "Custom MEtabox", "custom_metabox_field", "post", "normal", "low");
		}

		function custom_metabox_field() {
			echo '<input type="text" name="custom_input" id="custom_input" value=""/>';
		}


		/*
		 * These functions have not been tested. They were ported from what was created wayyyy back in the day
		 * when all kinds of hell broke loose, while refactoring the original plugin. It's probably not needed
		 * anymore, but I'm afraid to delete it. :/
		 *
		 * @keywordCleanupLogic, @selectKeywordLogic, @cleanUpVariables, @extractNewKeywords, @loopThroughParagraphWords
		 * Good luck, Future Dev.
		 */
		function keywordCleanupLogic( $newword, $nextword, $newkeywords, $result, $num, $v, $a ) {
			if ( ! empty( $newkeywords ) && ( $newkeywords[ $v ] == $newword || $newkeywords[ $v ] == $nextword ) ) {
				if ( ! isset( $this->replacement_link_info[ $newkeywords[ $v ] ] ) ) {
					for ( $i = 0; $i < count( $newkeywords ); $i ++ ) {
						$stmt = $this->wpdb->get_results( "SELECT {$this->keywordTable}.keywords FROM {$this->keywordTable} WHERE link_id = {$result[$num]->id}" );
						for ( $j = 0; $j <= count( $stmt ); $j ++ ) {
							$bio = $stmt[ $j ]->keywords;
							if ( strtolower( $bio ) == $newkeywords[ $v ] ) {
								$this->replacement_link_info[ $newkeywords[ $v ] ]['url']   = $a[ $stmt[ $j ]->keywords ][0];
								$this->replacement_link_info[ $newkeywords[ $v ] ]['count'] = 0;
							}
						}
					}
				}
				$this->selectKeywordLogic( $newkeywords, $newword, $splitwords, $wordcounter, $result, $num, $somevar, $a );
			}
		}

		function selectKeywordLogic( $newkeywords, $newword, $splitwords, $wordcounter, $result, $num, $somevar, $a ) {
			global $wpdb;
			for ( $v = 0; $v < count( $newkeywords ); $v ++ ) {
				$nextword = $newword . ' ' . $splitwords[ $wordcounter ];
				$nextword = preg_replace( "/[^a-z ']+/i", '', strip_tags( $nextword ) );
				$newword  = preg_replace( "/[^a-z ']+/i", '', strip_tags( $newword ) );
				if ( ! empty( $newkeywords ) && ( $newkeywords[ $v ] == $newword || $newkeywords[ $v ] == $nextword ) ) {
					if ( ! isset( $this->replacement_link_info[ $newkeywords[ $v ] ] ) ) {
						$this->keywordCleanupLogic( $newkeywords, $result, $v, $a );
					}
					if ( $somevar < $this->max_per_paragraph ) {
						$somevar ++;
						if ( $newkeywords[ $v ] == $nextword ) {
							$this->newPattern = $this->getLinks();
						} else {
							$this->newPattern = $this->getLinks();
						}
					} else {
						continue;
					}

				}
			}
		}

		function cleanUpVariables( $newkeywords, $splitwords, $newword, $wordcounter ) {
			for ( $v = 0; $v < count( $newkeywords ); $v ++ ) {
				/*
				 * Clean up the variables.
				 * Removing html and punctuation so only the keywords remain
				 */
				$nextword = $newword . ' ' . $splitwords[ $wordcounter ];
				$nextword = preg_replace( "/[^a-z ']+/i", '', strip_tags( $nextword ) );
				$newword  = preg_replace( "/[^a-z ']+/i", '', strip_tags( $newword ) );
				$this->keywordCleanupLogic( $newword, $nextword, $newkeywords, $result, $num, $v, $a );
			}
		}

		function extractNewKeywords( $wordcounter, $result ) {
			$wordcounter ++;
			for ( $num = 0; $num < count( $result ); $num ++ ) {
				$newkeywords = explode( ", ", $result[ $num ]->keywords );
				$this->cleanUpVariables( $newkeywords, $splitwords, $newword, $wordcounter );
			}
		}

		function loopThroughParagraphWords( $splitwords ) {
			foreach ( $splitwords as $newword ) {
				$this->extractNewKeywords( $wordcounter, $result );
			}
		}


        function db_data_setup(){
            global $wpdb;
            $data_version = '0.3.1';
            add_option('earthleylinkmgr_db_data_version', $data_version);

            /*******************
             ***  LINKS TABLE ***
             *******************/

            $sql = "INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('earthley', 'https://www.earthley.com', 'earthley', 'earthley', '1', '1', '0', '1', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com', `alias_link` = 'earthley', `escaped_alias_link` = 'earthley', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '1', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 1), 'earthley') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('soap', 'https://www.earthley.com/product/3-1-soap/', 'soap', 'soap', '1', '1', '0', '2', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/3-1-soap/', `alias_link` = 'soap', `escaped_alias_link` = 'soap', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '2', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 2), 'soap') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 2), '3 in 1') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 2), '3 in 1 bar') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 2), '3-in-1') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 2), '3-in-1 bar') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 2), '3-in-1 soap') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 2), 'body soap') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 2), 'dandruff') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 2), 'itchy scalp') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 2), 'shaving cream') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 2), 'shaving soap') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 2), 'soap bar') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('all purpose salve', 'https://www.earthley.com/product/all-purpose-salve-stick/', 'all purpose salve', 'all purpose salve', '1', '1', '0', '3', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/all-purpose-salve-stick/', `alias_link` = 'all purpose salve', `escaped_alias_link` = 'all purpose salve', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '3', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 3), 'all purpose salve') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 3), 'burn') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 3), 'burns') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 3), 'cuts and scrapes') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 3), 'first aid salve') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 3), 'rash') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 3), 'rashes') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 3), 'scrape') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 3), 'scrapes') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('all purpose spray', 'https://www.earthley.com/product/all-purpose-spray/', 'all purpose spray', 'all purpose spray', '1', '1', '0', '4', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/all-purpose-spray/', `alias_link` = 'all purpose spray', `escaped_alias_link` = 'all purpose spray', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '4', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 4), 'all purpose spray') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 4), 'antibacterial') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 4), 'antibacterial spray') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 4), 'body spray') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 4), 'cleaning spray') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 4), 'hand sanitizer') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('anxiety relief', 'https://www.earthley.com/product/anxiety-relief-herbal-extract/', 'anxiety relief', 'anxiety relief', '1', '1', '0', '5', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/anxiety-relief-herbal-extract/', `alias_link` = 'anxiety relief', `escaped_alias_link` = 'anxiety relief', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '5', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 5), 'anxiety relief') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 5), 'anxiety') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 5), 'anxious') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 5), 'balanced mood') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 5), 'depressed') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 5), 'depression') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 5), 'mood') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 5), 'relaxation') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 5), 'stress') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 5), 'stress relief') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 5), 'stressed') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('arnica salve', 'https://www.earthley.com/product/arnica-salve-stick/', 'arnica salve', 'arnica salve', '1', '1', '0', '6', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/arnica-salve-stick/', `alias_link` = 'arnica salve', `escaped_alias_link` = 'arnica salve', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '6', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 6), 'arnica salve') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 6), 'arnica') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 6), 'arnica cream') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 6), 'arnica gel') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 6), 'bruise') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 6), 'bruises') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 6), 'bruising') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 6), 'bumps') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 6), 'bumps and bruises') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 6), 'reduce pain') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 6), 'swelling') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 6), 'swollen') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('baby balm', 'https://www.earthley.com/product/baby-balm-herbal-salve/', 'baby balm', 'baby balm', '1', '1', '0', '7', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/baby-balm-herbal-salve/', `alias_link` = 'baby balm', `escaped_alias_link` = 'baby balm', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '7', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 7), 'baby balm') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 7), 'baby salve') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 7), 'butt cream') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 7), 'butt paste') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 7), 'butt rash') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 7), 'diaper cream') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 7), 'diaper rash') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('black drawing salve', 'https://www.earthley.com/product/black-drawing-salve-stick/', 'black drawing salve', 'black drawing salve', '1', '1', '0', '8', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/black-drawing-salve-stick/', `alias_link` = 'black drawing salve', `escaped_alias_link` = 'black drawing salve', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '8', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 8), 'black drawing salve') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 8), 'bee sting') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 8), 'bee stings') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 8), 'beesting') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 8), 'beestings') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 8), 'bug bite') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 8), 'bug bites') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 8), 'drawing salve') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 8), 'insect bite') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 8), 'insect bites') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 8), 'mosquito bite') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 8), 'mosquito bites') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 8), 'poison ivy') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 8), 'poison oak') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 8), 'poison sumac') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 8), 'spider bite') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 8), 'spider bites') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 8), 'splinter') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 8), 'splinters') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 8), 'sting') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 8), 'strings') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('breast balm', 'https://www.earthley.com/product/breast-balm-herbal-salve/', 'breast balm', 'breast balm', '1', '1', '0', '9', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/breast-balm-herbal-salve/', `alias_link` = 'breast balm', `escaped_alias_link` = 'breast balm', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '9', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 9), 'breast balm') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 9), 'breast salve') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 9), 'breast soreness') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 9), 'breast tenderness') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 9), 'breastfeeding balm') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 9), 'breastfeeding cream') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 9), 'cracked nipple') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 9), 'cracked nipples') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 9), 'damaged nipple') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 9), 'damaged nipples') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 9), 'nipple balm') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 9), 'nipple salve') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 9), 'nursing balm') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 9), 'nursing salve') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 9), 'sensitive nipple') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 9), 'sensitive nipples') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 9), 'sore nipple') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 9), 'sore nipples') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('breathe well salve', 'https://www.earthley.com/product/breathe-well-salve/', 'breathe well salve', 'breathe well salve', '1', '1', '0', '10', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/breathe-well-salve/', `alias_link` = 'breathe well salve', `escaped_alias_link` = 'breathe well salve', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '10', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 10), 'breathe well salve') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 10), 'breathe') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 10), 'breathe well') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 10), 'chest rub') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 10), 'clear breathing') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 10), 'congestion') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 10), 'respiratory congestion') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 10), 'respiratory support') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 10), 'sniffles') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 10), 'vapor rub') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('body lotion', 'https://www.earthley.com/product/calendula-rose-massage-oil/', 'body lotion', 'body lotion', '1', '1', '0', '11', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/calendula-rose-massage-oil/', `alias_link` = 'body lotion', `escaped_alias_link` = 'body lotion', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '11', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 11), 'body lotion') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 11), 'body oil') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 11), 'massage') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 11), 'massage oil') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('calm and clarity', 'https://www.earthley.com/product/calm-clarity-herbal-extract/', 'calm and clarity', 'calm and clarity', '1', '1', '0', '12', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/calm-clarity-herbal-extract/', `alias_link` = 'calm and clarity', `escaped_alias_link` = 'calm and clarity', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '12', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 12), 'calm and clarity') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 12), 'add') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 12), 'adhd') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 12), 'brain fog') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 12), 'focus') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 12), 'high needs') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 12), 'high-needs') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 12), 'mental calm') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 12), 'mental clarity') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 12), 'mental focus') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 12), 'mental fog') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 12), 'mthfr') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('calming essential oil', 'https://www.earthley.com/product/calming-essential-oil-roller/', 'calming essential oil', 'calming essential oil', '1', '1', '0', '13', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/calming-essential-oil-roller/', `alias_link` = 'calming essential oil', `escaped_alias_link` = 'calming essential oil', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '13', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 13), 'calming essential oil') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 13), 'calming eo') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('candida cleanse', 'https://www.earthley.com/product/candida-cleanse-herbal-extract/', 'candida cleanse', 'candida cleanse', '1', '1', '0', '14', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/candida-cleanse-herbal-extract/', `alias_link` = 'candida cleanse', `escaped_alias_link` = 'candida cleanse', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '14', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 14), 'candida cleanse') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 14), 'black walnut') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 14), 'candida') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 14), 'detox  ') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 14), 'parasite cleanse') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 14), 'parasite detox') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 14), 'wormwood') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 14), 'yeast detox') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('charcoal bar', 'https://www.earthley.com/product/charcoal-facial-bar/', 'charcoal bar', 'charcoal bar', '1', '1', '0', '15', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/charcoal-facial-bar/', `alias_link` = 'charcoal bar', `escaped_alias_link` = 'charcoal bar', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '15', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 15), 'charcoal bar') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 15), 'beauty bar') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 15), 'charcoal soap') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 15), 'facial bar') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 15), 'facial soap') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 15), 'oily skin') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('clear skin', 'https://www.earthley.com/product/clear-skin-essential-oil-roller/', 'clear skin', 'clear skin', '1', '1', '0', '16', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/clear-skin-essential-oil-roller/', `alias_link` = 'clear skin', `escaped_alias_link` = 'clear skin', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '16', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 16), 'clear skin') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 16), 'acne') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 16), 'acne treatment') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 16), 'blackhead') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 16), 'blemished treatment') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 16), 'skin blemish') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 16), 'teenage acne') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 16), 'whitehead') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('cough b gone', 'https://www.earthley.com/product/cough-b-gone-herbal-extract/', 'cough b gone', 'cough b gone', '1', '1', '0', '17', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/cough-b-gone-herbal-extract/', `alias_link` = 'cough b gone', `escaped_alias_link` = 'cough b gone', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '17', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 17), 'cough b gone') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 17), 'cough') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 17), 'coughing') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 17), 'coughs') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 17), 'lung health') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 17), 'lung remedy') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 17), 'lung support') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 17), 'sore throat') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('skin serum', 'https://www.earthley.com/product/deep-healing-skin-serum/', 'skin serum', 'skin serum', '1', '1', '0', '18', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/deep-healing-skin-serum/', `alias_link` = 'skin serum', `escaped_alias_link` = 'skin serum', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '18', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 18), 'skin serum') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 18), 'healing serum') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 18), 'healing skin') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 18), 'rosacea') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 18), 'scar') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 18), 'scars') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('mineral deodorant', 'https://www.earthley.com/product/detoxifying-deodorant/', 'mineral deodorant', 'mineral deodorant', '1', '1', '0', '19', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/detoxifying-deodorant/', `alias_link` = 'mineral deodorant', `escaped_alias_link` = 'mineral deodorant', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '19', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 19), 'mineral deodorant') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 19), 'antiperspirant') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 19), 'bo') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 19), 'body odor') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 19), 'deodorant') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 19), 'detoxifying deodorant') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 19), 'magnesium deodorant') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 19), 'natural deodorant') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 19), 'stinky pit') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 19), 'stinky pits') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('pit mask', 'https://www.earthley.com/product/detoxifying-pit-mask/', 'pit mask', 'pit mask', '1', '1', '0', '20', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/detoxifying-pit-mask/', `alias_link` = 'pit mask', `escaped_alias_link` = 'pit mask', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '20', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 20), 'pit mask') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 20), 'armpit detox') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 20), 'pit detox') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 20), 'underarm detox') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('digest ease', 'https://www.earthley.com/product/digest-ease-herbal-extract/', 'digest ease', 'digest ease', '1', '1', '0', '21', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/digest-ease-herbal-extract/', `alias_link` = 'digest ease', `escaped_alias_link` = 'digest ease', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '21', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 21), 'digest ease') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 21), 'bloating') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 21), 'constipation') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 21), 'diarrhea') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 21), 'nausea') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 21), 'nauseous') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 21), 'stomach issues') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 21), 'stomach pain') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 21), 'stomach problems') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('digest support', 'https://www.earthley.com/product/digest-support-digestive-bitters/', 'digest support', 'digest support', '1', '1', '0', '22', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/digest-support-digestive-bitters/', `alias_link` = 'digest support', `escaped_alias_link` = 'digest support', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '22', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 22), 'digest support') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 22), 'digestion') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 22), 'digestion support') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 22), 'digestive bitters') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 22), 'digestive distress') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 22), 'gut health') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 22), 'heartburn') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 22), 'herbal bitters') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 22), 'indigestion') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 22), 'upset stomach') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('earache ease', 'https://www.earthley.com/product/earache-ease/', 'earache ease', 'earache ease', '1', '1', '0', '23', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/earache-ease/', `alias_link` = 'earache ease', `escaped_alias_link` = 'earache ease', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '23', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 23), 'earache ease') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 23), 'ear drop') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 23), 'ear drops') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 23), 'ear infection') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 23), 'ear infections') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 23), 'earache') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 23), 'garlic-mullein oil') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 23), 'swimmers ear') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 23), 'swimmer\'s ear') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('ease the ache', 'https://www.earthley.com/product/ease-the-ache-womens-cramp-formula/', 'ease the ache', 'ease the ache', '1', '1', '0', '24', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/ease-the-ache-womens-cramp-formula/', `alias_link` = 'ease the ache', `escaped_alias_link` = 'ease the ache', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '24', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 24), 'ease the ache') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 24), 'after pains') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 24), 'afterpains') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 24), 'aunt flo') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 24), 'cramp relief') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 24), 'cramp remedies') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 24), 'cramp remedy') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 24), 'cramps') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 24), 'heavy bleeding') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 24), 'menstrual') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 24), 'menstrual cramps') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 24), 'period') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 24), 'pms') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 24), 'postpartum cramps') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 24), 'postpartum pain') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 24), 'time of the month') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('elderberry elixir', 'https://www.earthley.com/product/elderberry-elixir-herbal-extract/', 'elderberry elixir', 'elderberry elixir', '1', '1', '0', '25', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/elderberry-elixir-herbal-extract/', `alias_link` = 'elderberry elixir', `escaped_alias_link` = 'elderberry elixir', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '25', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 25), 'elderberry elixir') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 25), 'anti-viral') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 25), 'cold prevention') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 25), 'cold remedies') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 25), 'cold remedy') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 25), 'cold symptoms') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 25), 'elderberry') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 25), 'elderberry syrup') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 25), 'elderberry tincture') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 25), 'flu fighter') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 25), 'flu prevention') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 25), 'flu remedies') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 25), 'flu remedy') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 25), 'flu shot') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 25), 'flu symptoms') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 25), 'flu vaccine') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 25), 'flumist') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 25), 'immune support') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 25), 'quercetin') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 25), 'sambucol') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 25), 'sambucus') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 25), 'sinus infection') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 25), 'sinusitis') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('elderberry kit', 'https://www.earthley.com/product/elderberry-syrup-diy-kits/', 'elderberry kit', 'elderberry kit', '1', '1', '0', '26', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/elderberry-syrup-diy-kits/', `alias_link` = 'elderberry kit', `escaped_alias_link` = 'elderberry kit', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '26', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 26), 'elderberry kit') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 26), 'diy elderberry') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('energy plus', 'https://www.earthley.com/product/energy-plus-herbal-iron/', 'energy plus', 'energy plus', '1', '1', '0', '27', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/energy-plus-herbal-iron/', `alias_link` = 'energy plus', `escaped_alias_link` = 'energy plus', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '27', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 27), 'energy plus') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 27), 'anemia') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 27), 'b vitamins') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 27), 'b-complex') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 27), 'energy') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 27), 'energy boost') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 27), 'floradix') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 27), 'hemorrhage') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 27), 'herbal iron') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 27), 'iron  ') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 27), 'iron supplement') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 27), 'low energy') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 27), 'more energy') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 27), 'rosehips') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('exfoiliating skin cream', 'https://www.earthley.com/product/exfoliating-skin-cream/', 'exfoiliating skin cream', 'exfoiliating skin cream', '1', '1', '0', '28', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/exfoliating-skin-cream/', `alias_link` = 'exfoiliating skin cream', `escaped_alias_link` = 'exfoiliating skin cream', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '28', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 28), 'exfoiliating skin cream') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 28), 'exfoiliating') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 28), 'exfoiliating cream') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 28), 'exfoliate') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 28), 'skin treatment') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('fertility boost', 'https://www.earthley.com/product/fertili-boost-herbal-extract/', 'fertility boost', 'fertility boost', '1', '1', '0', '29', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/fertili-boost-herbal-extract/', `alias_link` = 'fertility boost', `escaped_alias_link` = 'fertility boost', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '29', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 29), 'fertility boost') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 29), 'conceive') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 29), 'conception') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 29), 'fertility') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 29), 'infertility') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 29), 'luteal phase') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 29), 'miscarriage') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 29), 'pre-conception') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 29), 'pregnancy hormones') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 29), 'progesterone') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 29), 'schisandra') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 29), 'ttc') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('good night lotion', 'https://www.earthley.com/product/good-night-lotion/', 'good night lotion', 'good night lotion', '1', '1', '0', '30', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/good-night-lotion/', `alias_link` = 'good night lotion', `escaped_alias_link` = 'good night lotion', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '30', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 30), 'good night lotion') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 30), 'charley horse') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 30), 'dream cream') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 30), 'insomnia') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 30), 'leg cramp') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 30), 'leg cramps') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 30), 'magnesium cream') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 30), 'magnesium gel') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 30), 'magnesium lotion') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 30), 'magnesium oil') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 30), 'magnesium spray') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 30), 'manesium supplment') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 30), 'pregnancy sleep') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 30), 'restless leg') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 30), 'restless legs') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 30), 'sleep') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 30), 'sleeplessness') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('herbal baby powder', 'https://www.earthley.com/product/herbal-baby-powder/', 'herbal baby powder', 'herbal baby powder', '1', '1', '0', '31', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/herbal-baby-powder/', `alias_link` = 'herbal baby powder', `escaped_alias_link` = 'herbal baby powder', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '31', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 31), 'herbal baby powder') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 31), 'baby powder') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 31), 'cord care') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 31), 'cornstarch') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 31), 'drool rash') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 31), 'goldenseal root') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 31), 'umbilical cord') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('herbal soothing bath', 'https://www.earthley.com/product/herbal-soothing-bath/', 'herbal soothing bath', 'herbal soothing bath', '1', '1', '0', '32', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/herbal-soothing-bath/', `alias_link` = 'herbal soothing bath', `escaped_alias_link` = 'herbal soothing bath', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '32', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 32), 'herbal soothing bath') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 32), 'detox bath') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 32), 'fever') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 32), 'healing bath') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 32), 'herbal bath') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 32), 'postpartum bath') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 32), 'soothing bath') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('immune aid', 'https://www.earthley.com/product/immune-aid-vitamin-c-powder/', 'immune aid', 'immune aid', '1', '1', '0', '33', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/immune-aid-vitamin-c-powder/', `alias_link` = 'immune aid', `escaped_alias_link` = 'immune aid', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '33', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 33), 'immune aid') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 33), 'acerola') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 33), 'bioflavanoid') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 33), 'bioflavanoids') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 33), 'camu camu') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 33), 'immune health') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 33), 'vitamin c') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 33), 'vitamin c powder') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('immune biotic', 'https://www.earthley.com/product/immune-biotic-herbal-extract/', 'immune biotic', 'immune biotic', '1', '1', '0', '34', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/immune-biotic-herbal-extract/', `alias_link` = 'immune biotic', `escaped_alias_link` = 'immune biotic', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '34', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 34), 'immune biotic') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 34), 'anti-bacterial') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 34), 'antibiotic') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 34), 'illness relief') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 34), 'illness support') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 34), 'immune boost') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 34), 'immune boosting') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('infant tummy relief', 'https://www.earthley.com/product/infant-tummy-relief/', 'infant tummy relief', 'infant tummy relief', '1', '1', '0', '35', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/infant-tummy-relief/', `alias_link` = 'infant tummy relief', `escaped_alias_link` = 'infant tummy relief', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '35', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 35), 'infant tummy relief') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 35), 'colic') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 35), 'fussiness') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 35), 'gas  ') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 35), 'gas drops') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 35), 'gripe water') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 35), 'infant tummy') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 35), 'upset tummy') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 35), 'vomiting') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('green clay mask', 'https://www.earthley.com/product/lavender-green-clay-mask/', 'green clay mask', 'green clay mask', '1', '1', '0', '36', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/lavender-green-clay-mask/', `alias_link` = 'green clay mask', `escaped_alias_link` = 'green clay mask', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '36', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 36), 'green clay mask') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 36), 'clay mask') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 36), 'detox skin') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 36), 'drawing mask') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 36), 'face mask') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 36), 'facial mask') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 36), 'french clay mask') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 36), 'lavender mask') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 36), 'skin detox') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('liver love', 'https://www.earthley.com/product/liver-love-herbal-tincture/', 'liver love', 'liver love', '1', '1', '0', '37', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/liver-love-herbal-tincture/', `alias_link` = 'liver love', `escaped_alias_link` = 'liver love', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '37', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 37), 'liver love') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 37), 'liver cleanse') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 37), 'liver detox') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 37), 'liver supplement') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 37), 'liver support') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('magic muscle ease', 'https://www.earthley.com/product/magic-muscle-ease/', 'magic muscle ease', 'magic muscle ease', '1', '1', '0', '38', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/magic-muscle-ease/', `alias_link` = 'magic muscle ease', `escaped_alias_link` = 'magic muscle ease', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '38', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 38), 'magic muscle ease') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 38), 'back pain') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 38), 'backache') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 38), 'muscle pain') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 38), 'muscle salve') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 38), 'muscle stiffness') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 38), 'muscle tension') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 38), 'muscle tightness') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 38), 'neck pain') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 38), 'sore muscle') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 38), 'sore muscles') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 38), 'sprain') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 38), 'strained muscle') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 38), 'twisted ankle') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('milk boost', 'https://www.earthley.com/product/mamas-milk-boost/', 'milk boost', 'milk boost', '1', '1', '0', '39', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/mamas-milk-boost/', `alias_link` = 'milk boost', `escaped_alias_link` = 'milk boost', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '39', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 39), 'milk boost') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 39), 'breast milk') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 39), 'breast milk boost') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 39), 'breast milk booster') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 39), 'lactation aid') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 39), 'milk production') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 39), 'milk supply') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 39), 'mother\'s lactation') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 39), 'mother\'s milk') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('tummy relief', 'https://www.earthley.com/product/mamas-tummy-relief/', 'tummy relief', 'tummy relief', '1', '1', '0', '40', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/mamas-tummy-relief/', `alias_link` = 'tummy relief', `escaped_alias_link` = 'tummy relief', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '40', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 40), 'tummy relief') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 40), 'b6') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 40), 'h.pylori') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 40), 'morning sickness') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 40), 'pregnancy nausea') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 40), 'queasiness') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 40), 'queasy') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 40), 'vitamin b6') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('milk flowin', 'https://www.earthley.com/product/milk-flowin-salve/', 'milk flowin', 'milk flowin', '1', '1', '0', '41', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/milk-flowin-salve/', `alias_link` = 'milk flowin', `escaped_alias_link` = 'milk flowin', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '41', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 41), 'milk flowin') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 41), 'blocked milk duct') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 41), 'blocked milk ducts') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 41), 'breast imflammation') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 41), 'breastfeeding support') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 41), 'clogged duct') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 41), 'clogged ducts') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 41), 'clogged milk duct') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 41), 'clogged milk ducts') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 41), 'mastitis') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 41), 'plugged duct') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 41), 'plugged ducts') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('moisturize me', 'https://www.earthley.com/product/moisturize-me/', 'moisturize me', 'moisturize me', '1', '1', '0', '42', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/moisturize-me/', `alias_link` = 'moisturize me', `escaped_alias_link` = 'moisturize me', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '42', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 42), 'moisturize me') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 42), 'moisturizer') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 42), 'skin cream') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('hormone balance', 'https://www.earthley.com/product/natural-balance/', 'hormone balance', 'hormone balance', '1', '1', '0', '43', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/natural-balance/', `alias_link` = 'hormone balance', `escaped_alias_link` = 'hormone balance', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '43', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 43), 'hormone balance') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 43), 'adaptogenic') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 43), 'adrenal') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 43), 'adrenal fatigue') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 43), 'adrenal support') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 43), 'cortisol') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('hair care', 'https://www.earthley.com/product/natural-hair-care-bundle/', 'hair care', 'hair care', '1', '1', '0', '44', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/natural-hair-care-bundle/', `alias_link` = 'hair care', `escaped_alias_link` = 'hair care', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '44', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 44), 'hair care') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 44), 'curly hair') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 44), 'dry hair') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 44), 'fine hair') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 44), 'natural hair') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 44), 'oily hair') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 44), 'thick hair') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('lip balm', 'https://www.earthley.com/product/natural-lip-balm/', 'lip balm', 'lip balm', '1', '1', '0', '45', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/natural-lip-balm/', `alias_link` = 'lip balm', `escaped_alias_link` = 'lip balm', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '45', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 45), 'lip balm') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 45), 'chapped lips') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 45), 'chapstick') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 45), 'cracked lips') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 45), 'dry lips') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('nourish her naturally', 'https://www.earthley.com/product/nourish-her-naturally/', 'nourish her naturally', 'nourish her naturally', '1', '1', '0', '46', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/nourish-her-naturally/', `alias_link` = 'nourish her naturally', `escaped_alias_link` = 'nourish her naturally', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '46', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 46), 'nourish her naturally') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 46), 'female vitamin') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 46), 'female vitamins') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 46), 'prenatal vitamin') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 46), 'prenatal vitamins') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 46), 'women\'s multivitamin') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 46), 'women\'s multivitamins') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 46), 'women\'s nutrition') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 46), 'women\'s vitamin') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 46), 'women\'s vitamins') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('nourish him naturally', 'https://www.earthley.com/product/nourish-him-naturally/', 'nourish him naturally', 'nourish him naturally', '1', '1', '0', '47', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/nourish-him-naturally/', `alias_link` = 'nourish him naturally', `escaped_alias_link` = 'nourish him naturally', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '47', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 47), 'nourish him naturally') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 47), 'cardiovascular health') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 47), 'heart health') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 47), 'male vitamin') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 47), 'male vitamins') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 47), 'men\'s multivitamin') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 47), 'men\'s multivitamins') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 47), 'men\'s nutrition') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 47), 'men\'s vitamin') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 47), 'men\'s vitamins') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 47), 'prostate health') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('nourish me naturally', 'https://www.earthley.com/product/nourish-naturally-herbal-multivitamin-extract/', 'nourish me naturally', 'nourish me naturally', '1', '1', '0', '48', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/nourish-naturally-herbal-multivitamin-extract/', `alias_link` = 'nourish me naturally', `escaped_alias_link` = 'nourish me naturally', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '48', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 48), 'nourish me naturally') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 48), 'children\'s multivitamin') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 48), 'children\'s multivitamins') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 48), 'children\'s vitamin') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 48), 'children\'s vitamins') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 48), 'herbal vitamin') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 48), 'kid\'s multivitamin') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 48), 'kid\'s multivitamins') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 48), 'kid\'s vitamin') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 48), 'kid\'s vitamins') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 48), 'multivitamin') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 48), 'vitamin') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('yeast salve', 'https://www.earthley.com/product/no-yeast-salve/', 'yeast salve', 'yeast salve', '1', '1', '0', '49', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/no-yeast-salve/', `alias_link` = 'yeast salve', `escaped_alias_link` = 'yeast salve', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '49', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 49), 'yeast salve') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 49), 'anti-fungal') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 49), 'athlete\'s foot') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 49), 'cradle cap') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 49), 'fungal rash') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 49), 'fungal rashes') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 49), 'jock itch') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 49), 'molloscum') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 49), 'thrush') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 49), 'yeast  ') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 49), 'yeast infection') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 49), 'yeast infections') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 49), 'yeast overgrowth') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 49), 'yeast rash') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 49), 'yeast rashes') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('oatmeal and honey soap', 'https://www.earthley.com/product/oatmeal-honey-soap/', 'oatmeal and honey soap', 'oatmeal and honey soap', '1', '1', '0', '50', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/oatmeal-honey-soap/', `alias_link` = 'oatmeal and honey soap', `escaped_alias_link` = 'oatmeal and honey soap', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '50', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 50), 'oatmeal and honey soap') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 50), 'eczema soap') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 50), 'gentle soap') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 50), 'honey soap') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 50), 'oat and honey soap') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 50), 'oatmeal soap') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 50), 'soap for sensitive skin') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('pain potion', 'https://www.earthley.com/product/pain-potion/', 'pain potion', 'pain potion', '1', '1', '0', '51', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/pain-potion/', `alias_link` = 'pain potion', `escaped_alias_link` = 'pain potion', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '51', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 51), 'pain potion') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 51), 'arthritis') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 51), 'fibormyalgia') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 51), 'headache') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 51), 'migraine') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 51), 'nerve pain') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 51), 'pain') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 51), 'pain relief') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 51), 'painkiller') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 51), 'pain-relieving ') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('pest aside', 'https://www.earthley.com/product/pest-aside/', 'pest aside', 'pest aside', '1', '1', '0', '52', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/pest-aside/', `alias_link` = 'pest aside', `escaped_alias_link` = 'pest aside', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '52', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 52), 'pest aside') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 52), 'bug repellent') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 52), 'bug spray') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 52), 'insect repellent') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 52), 'lice repellent') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 52), 'mosquitoe repellent') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 52), 'pesticide') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 52), 'tick repellent') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('postpartum balance', 'https://www.earthley.com/product/postpartum-balance/', 'postpartum balance', 'postpartum balance', '1', '1', '0', '53', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/postpartum-balance/', `alias_link` = 'postpartum balance', `escaped_alias_link` = 'postpartum balance', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '53', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 53), 'postpartum balance') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 53), 'postpartum  ') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 53), 'postpartum hair loss') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 53), 'postpartum health') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 53), 'postpartum hormones') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 53), 'postpartum support') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 53), 'ppd') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('pregnancy tea', 'https://www.earthley.com/product/pregnancy-tea/', 'pregnancy tea', 'pregnancy tea', '1', '1', '0', '54', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/pregnancy-tea/', `alias_link` = 'pregnancy tea', `escaped_alias_link` = 'pregnancy tea', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '54', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 54), 'pregnancy tea') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 54), 'labor prep') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 54), 'pregnancy nutrition') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 54), 'red raspberry leaf') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('pumpkin spice lip balm', 'https://www.earthley.com/product/pumpkin-spice-lip-balm/', 'pumpkin spice lip balm', 'pumpkin spice lip balm', '1', '1', '0', '55', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/pumpkin-spice-lip-balm/', `alias_link` = 'pumpkin spice lip balm', `escaped_alias_link` = 'pumpkin spice lip balm', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '55', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 55), 'pumpkin spice lip balm') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('pumpkin spice whipped body butter', 'https://www.earthley.com/product/pumpkin-spice-whipped-body-butter/', 'pumpkin spice whipped body butter', 'pumpkin spice whipped body butter', '1', '1', '0', '56', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/pumpkin-spice-whipped-body-butter/', `alias_link` = 'pumpkin spice whipped body butter', `escaped_alias_link` = 'pumpkin spice whipped body butter', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '56', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 56), 'pumpkin spice whipped body butter') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('rejuvinate me', 'https://www.earthley.com/product/rejuvenate-facial-serum/', 'rejuvinate me', 'rejuvinate me', '1', '1', '0', '57', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/rejuvenate-facial-serum/', `alias_link` = 'rejuvinate me', `escaped_alias_link` = 'rejuvinate me', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '57', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 57), 'rejuvinate me') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 57), 'acne scar') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 57), 'acne scars') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 57), 'face serum') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 57), 'facial serum') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 57), 'fine lines') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 57), 'night serum') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 57), 'rejuvinate') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 57), 'serum') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 57), 'skin care spf') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 57), 'skin damage') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 57), 'wrinkle') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 57), 'wrinkles') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('tooth powder', 'https://www.earthley.com/product/remineralizing-tooth-powder/', 'tooth powder', 'tooth powder', '1', '1', '0', '58', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/remineralizing-tooth-powder/', `alias_link` = 'tooth powder', `escaped_alias_link` = 'tooth powder', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '58', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 58), 'tooth powder') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 58), 'dental health') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 58), 'heal cavities') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 58), 'oral care') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 58), 'oral health') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 58), 'oral hygene') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 58), 'prevent cavities') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 58), 'remineralizing') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 58), 'stained teeth') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 58), 'teeth stain') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 58), 'teeth stains') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 58), 'tooth whitening') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 58), 'toothpaste') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('shampoo bar', 'https://www.earthley.com/product/rosemary-lavender-shampoo-bar/', 'shampoo bar', 'shampoo bar', '1', '1', '0', '59', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/rosemary-lavender-shampoo-bar/', `alias_link` = 'shampoo bar', `escaped_alias_link` = 'shampoo bar', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '59', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 59), 'shampoo bar') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 59), 'shampoo') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('conditioner', 'https://www.earthley.com/product/silky-smooth-leave-conditioner/', 'conditioner', 'conditioner', '1', '1', '0', '60', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/silky-smooth-leave-conditioner/', `alias_link` = 'conditioner', `escaped_alias_link` = 'conditioner', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '60', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 60), 'conditioner') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 60), 'detangler') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 60), 'leave in conditioner') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 60), 'leave-in conditioner') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('sinus saver', 'https://www.earthley.com/product/sinus-saver/', 'sinus saver', 'sinus saver', '1', '1', '0', '61', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/sinus-saver/', `alias_link` = 'sinus saver', `escaped_alias_link` = 'sinus saver', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '61', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 61), 'sinus saver') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 61), 'histamine') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 61), 'histamines') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 61), 'itchy eyes') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 61), 'nettle leaf') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 61), 'nettles') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 61), 'scratchy throat') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 61), 'seasonal allergies') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 61), 'seasonal allergy') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 61), 'sneezing') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 61), 'watery eyes') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('skin care', 'https://www.earthley.com/product/skin-care-trial-set/', 'skin care', 'skin care', '1', '1', '0', '62', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/skin-care-trial-set/', `alias_link` = 'skin care', `escaped_alias_link` = 'skin care', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '62', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 62), 'skin care') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 62), 'face care') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 62), 'facial care') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 62), 'natural skin care') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('sleepy time', 'https://www.earthley.com/product/sleepy-time-herbal-extract/', 'sleepy time', 'sleepy time', '1', '1', '0', '63', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/sleepy-time-herbal-extract/', `alias_link` = 'sleepy time', `escaped_alias_link` = 'sleepy time', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '63', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 63), 'sleepy time') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 63), 'calm mood') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 63), 'restful sleep') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 63), 'sleep deprivation') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 63), 'sleep-deprived') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('soothing belly butter', 'https://www.earthley.com/product/soothing-belly-butter/', 'soothing belly butter', 'soothing belly butter', '1', '1', '0', '64', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/soothing-belly-butter/', `alias_link` = 'soothing belly butter', `escaped_alias_link` = 'soothing belly butter', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '64', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 64), 'soothing belly butter') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 64), 'belly butter') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 64), 'cocoa butter') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 64), 'itchy belly') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 64), 'pregnant belly') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 64), 'stretch marks') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('soothing skin balm', 'https://www.earthley.com/product/soothing-skin-balm/', 'soothing skin balm', 'soothing skin balm', '1', '1', '0', '65', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/soothing-skin-balm/', `alias_link` = 'soothing skin balm', `escaped_alias_link` = 'soothing skin balm', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '65', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 65), 'soothing skin balm') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 65), 'dermatitis') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 65), 'dry skin') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 65), 'eczema') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 65), 'itchy skin') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 65), 'psoriasis') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 65), 'rough skin') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 65), 'sensitive skin') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 65), 'skin balm') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('sun shield', 'https://www.earthley.com/product/sun-shield/', 'sun shield', 'sun shield', '1', '1', '0', '66', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/sun-shield/', `alias_link` = 'sun shield', `escaped_alias_link` = 'sun shield', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '66', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 66), 'sun shield') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 66), 'skin protector') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 66), 'sun lotion') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 66), 'sun protection') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 66), 'sunscreen') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 66), 'uvb protection') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('after-sun lotion', 'https://www.earthley.com/product/sun-soothe-after-sun-lotion/', 'after-sun lotion', 'after-sun lotion', '1', '1', '0', '67', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/sun-soothe-after-sun-lotion/', `alias_link` = 'after-sun lotion', `escaped_alias_link` = 'after-sun lotion', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '67', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 67), 'after-sun lotion') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 67), 'aloe vera') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 67), 'cellular damage') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 67), 'sun soothe') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 67), 'sunburn') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 67), 'uva damage') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 67), 'uvb damage') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('teeth tamer', 'https://www.earthley.com/product/teeth-tamer-herbal-extract/', 'teeth tamer', 'teeth tamer', '1', '1', '0', '68', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/teeth-tamer-herbal-extract/', `alias_link` = 'teeth tamer', `escaped_alias_link` = 'teeth tamer', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '68', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 68), 'teeth tamer') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 68), 'molars') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 68), 'oral pain') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 68), 'teeth pain') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 68), 'teething') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 68), 'teething oil') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 68), 'tooth pain') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 68), 'toothache') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 68), 'wisdom teeth') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 68), 'wisdom tooth') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('facial toner', 'https://www.earthley.com/product/tone-me/', 'facial toner', 'facial toner', '1', '1', '0', '69', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/tone-me/', `alias_link` = 'facial toner', `escaped_alias_link` = 'facial toner', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '69', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 69), 'facial toner') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('ut relief', 'https://www.earthley.com/product/ut-relief-herbal-extract/', 'ut relief', 'ut relief', '1', '1', '0', '70', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/ut-relief-herbal-extract/', `alias_link` = 'ut relief', `escaped_alias_link` = 'ut relief', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '70', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 70), 'ut relief') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 70), 'bladder health') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 70), 'd-mannose') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 70), 'kidney support') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 70), 'urinary tract health') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 70), 'urinary tract infection') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 70), 'uti') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('body butter', 'https://www.earthley.com/product/whipped-body-butter/', 'body butter', 'body butter', '1', '1', '0', '71', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product/whipped-body-butter/', `alias_link` = 'body butter', `escaped_alias_link` = 'body butter', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '71', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 71), 'body butter') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 71), 'whipped body butter') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('breastfeeding', 'https://www.earthley.com/product-category/breastfeeding-support/', 'breastfeeding', 'breastfeeding', '1', '1', '0', '72', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product-category/breastfeeding-support/', `alias_link` = 'breastfeeding', `escaped_alias_link` = 'breastfeeding', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '72', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 72), 'breastfeeding') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('herbal remedies', 'https://www.earthley.com/product-category/herbal-remedies-for-the-family/', 'herbal remedies', 'herbal remedies', '1', '1', '0', '73', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product-category/herbal-remedies-for-the-family/', `alias_link` = 'herbal remedies', `escaped_alias_link` = 'herbal remedies', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '73', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 73), 'herbal remedies') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 73), 'herbal remedy') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 73), 'natural remedies') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 73), 'natural remedy') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_links` (`link_title`, `link_dest`, `alias_link`, `escaped_alias_link`, `new_window`, `no_follow`, `replace_existing_links`, `master_record`, `active`, `status`) VALUES ('herbal supplements', 'https://www.earthley.com/product-category/supplements-for-the-family/', 'herbal supplements', 'herbal supplements', '1', '1', '0', '74', '1', '0') ON DUPLICATE KEY UPDATE `link_dest` = 'https://www.earthley.com/product-category/supplements-for-the-family/', `alias_link` = 'herbal supplements', `escaped_alias_link` = 'herbal supplements', `new_window` = '1', `no_follow` = '1', `replace_existing_links` = '0', `master_record` = '74', `active` = '1', `status` = '0'; INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 74), 'herbal supplements') ON DUPLICATE KEY UPDATE id=id;	
            INSERT INTO `" . $this->wpdb->prefix . "earthleylinkmgr_keywords` (`link_id`, `keywords`) VALUES ((SELECT `id` FROM `" . $this->wpdb->prefix . "earthleylinkmgr_links` WHERE `master_record` = 74), 'herbal supplement') ON DUPLICATE KEY UPDATE id=id;";

            dbDelta( $sql );
        }
	}
}